library IEForm;

uses
  windows,
  SysUtils,
  Messages,
  ComObj,
  Variants,
  ShDocVwEvents,
  WinInet,
  CommCtrl;

{$R IEForm.res} // une faon de faire pour stock l'icone de la commande c'est de la placer dans le fichier ressource

const
WM_PLUGIN_MSG = WM_USER + 1234;
WM_POS_ORDER = WM_USER + 1237;
PLUGIN_ERROR_OF_EXECUTE = WM_USER + 1240;
// +-->
        PLUGIN_CANCEL_NEW_OR_CHANGE_ORDER = 0;  // annonce a super macro que l'ajout ou la modification a t annul
        PLUGIN_GET_MACRO_FILENAME = 1;          // reoit dans les parametres de GetInfoFromSMacro parametre PcharValue le nom de la macro courante
        //PLUGIN_GET_VARIABLE_FILENAME = 2;     // reoit dans les parametres de GetInfoFromSMacro parametre PcharValue le nom de du fichier des variables
        PLUGIN_GET_CONFIG_FILENAME = 3;         // reoit dans les parametres de GetInfoFromSMacro parametre PcharValue le nom du fichier de configuration
        PLUGIN_GET_CHAR_SEPARATION = 4;         // reoit dans les parametres de GetInfoFromSMacro parametre PcharValue le caractre de sparation des parametres
        PLUGIN_GET_COUNT_ORDER = 5;             // reoit dans les parametres de GetInfoFromSMacro parametre IntegerValue le nombre de commande dans la macro courante
        PLUGIN_GET_BACKGROUND_HANDLE = 6;       // reoit le handle du graphique de l'image de fond
        PLUGIN_GETFONT_APPLICATION = 7;
        PLUGIN_GETFONTCOLOR_APPLICATION = 8;
        PLUGIN_GET_VARIABLE_COUNT = 1000;       // reoit dans les parametres de GetInfoFromSMacro parametre IntegerValue le nombre de variables dclares dans la macro courante
        PLUGIN_GET_PARAM = 10;      //+1 to 20  // reoit dans les parametres de GetInfoFromSMacro parametre PcharValue le parametre de la commande utiliser PLUGIN_GET_PARAM + 1  20 (puique 20 paramtres au maximum)
        PLUGIN_GET_VAR_NAME = 1000; //+1 to 999 // reoit dans les parametres de GetInfoFromSMacro parametre PcharValue le nom d'une variable suivant l'indice 1  ...  (voir PLUGIN_GET_VARIABLE_COUNT)
        PLUGIN_GET_VAR_TYPE = 2000; //+1 to 999 // reoit dans les parametres de GetInfoFromSMacro parametre PcharValue le type d'une variable suivant l'indice 1  ... (voir PLUGIN_GET_VARIABLE_COUNT) posible values are "No_Type", "Alpha" or "Numerique"

// exemple for know the name of current macro to Super macro
// Sendmessage(SmacroHandle, WM_PLUGIN_MSG, LibraryHandle, PLUGIN_GET_VARIABLE_FILENAME);
// provoque GetInfoFromSMacro with values return into params

const
WM_LIST_ORDER = WM_USER + 1236;
// +--> index 1 to ...

GET_VAR_VALUE = WM_USER + 1238;
SET_VAR_VALUE = WM_USER + 1239;
WM_ADD_ORDER = WM_USER + 1241;

  IDD_FENETRE                     = 102;        //  Handle de la fenetre
  IDC_EDIT                        = 10;
  IDC_TypeObj                     = 11;
  IDC_TAGID                       = 12;
  IDC_LIST                        = 13;
  IDC_COMBOBOX                    = 14;
  IDC_FRAME                       = 15;
  IDC_SHOW                        = 16;

  IDC_GO                          = 20;
  IDC_BOUTON1                     = 21;          //  Bt Valider
  IDC_BOUTON2                     = 22;          //  Bt Annuler
  IDC_BOUTON3                     = 23;
  IDC_LABEL6                      = 56;

const TagList : array[0..16] of String = ('Aucun','button','checkbox','file','hidden','image','link','password','radio','reset','submit','script','select','text','textarea','Php Var','source');

type TSelect = record
     Value : array of string;
     end;

type
   TEventHandlers = class // create a dummy class
   procedure NavigateError(Sender: TObject;const pDisp: IDispatch; var URL, Frame, StatusCode: OleVariant;var Cancel: WordBool);
   end;

type TStatusCodeMsg = record
     value : integer;
     Msg : String;
     end;

type TListStatusCodeMsg = class
     private
     Items : array of TStatusCodeMsg;
     count : Integer;
     public
     constructor create();
     function Find(Code : integer) : String;
     end;

var
//  variable qui stock les valeurs retournes par super macro lorsque l'on utilise
    SMacroInfo : Pchar = '';
    SMacroPcharValue : Pchar = '';
    SMacroStrValue : string = '';
    SMacroIntegerValue : integer;
    SMacroInfoCorrect : Boolean;

    GetListOrder_Order : String;
    GetListOrder_Param : String;

    SmacroHandle : hwnd = 0;
    LibraryHandle : hwnd = 0;
    Wait : Boolean = False;
    Stop : Boolean;
    AStringToPchar : array[1..255]of char;
    resultParam : String;
    g_hDlg : HWND;
    SprPr : string; // caractre de sparation
    tmpIEApp,IEApp : OLEVariant;
    ListTagId : array of integer;
    ListSelect : array of TSelect;
    WebBrowserEvents: TDWebBrowserEvents2;
    EvHandler:TEventHandlers;
    StatusCodeObj : TListStatusCodeMsg;


constructor TListStatusCodeMsg.Create();
procedure Add(Val : integer; Msg : String);
begin
SetLength(Items,length(Items)+1);
Items[length(Items)-1].value := Val;
Items[length(Items)-1].Msg := Msg;
Inc(Count);
end;
begin
Count := 0;
Add(502,'HTTP_STATUS_BAD_GATEWAY (502)');
Add(405,'HTTP_STATUS_BAD_METHOD (405)');
Add(400,'HTTP_STATUS_BAD_REQUEST (400)');
Add(409,'HTTP_STATUS_CONFLICT (409)');
Add(401,'HTTP_STATUS_DENIED (401)');
Add(403,'HTTP_STATUS_FORBIDDEN (403)');
Add(504,'HTTP_STATUS_GATEWAY_TIMEOUT (504)');
Add(410,'HTTP_STATUS_GONE (410)');
Add(411,'HTTP_STATUS_LENGTH_REQUIRED (411)');
Add(406,'HTTP_STATUS_NONE_ACCEPTABLE (406)');
Add(404,'HTTP_STATUS_NOT_FOUND (404)');
Add(501,'HTTP_STATUS_NOT_SUPPORTED (501)');
Add(402,'HTTP_STATUS_PAYMENT_REQ (402)');
Add(412,'HTTP_STATUS_PRECOND_FAILED (412)');
Add(407,'HTTP_STATUS_PROXY_AUTH_REQ (407)');
Add(408,'HTTP_STATUS_REQUEST_TIMEOUT (408)');
Add(413,'HTTP_STATUS_REQUEST_TOO_LARGE (413)');
Add(449,'HTTP_STATUS_RETRY_WITH (449)');
Add(500,'HTTP_STATUS_SERVER_ERROR (500)');
Add(503,'HTTP_STATUS_SERVICE_UNAVAIL (503)');
Add(415,'HTTP_STATUS_UNSUPPORTED_MEDIA (415)');
Add(414,'HTTP_STATUS_URI_TOO_LONG (414)');
Add(505,'HTTP_STATUS_VERSION_NOT_SUP (505)');

Add(-2146697207,'INET_E_AUTHENTICATION_REQUIRED');
Add(-2146697212,'INET_E_CANNOT_CONNECT');
Add(-2146697200,'INET_E_CANNOT_INSTANTIATE_OBJECT');
Add(-2146697201,'INET_E_CANNOT_LOAD_DATA');
Add(-2146697194,'INET_E_CANNOT_LOCK_REQUEST');
Add(-2146696448,'INET_E_CANNOT_REPLACE_SFP_FILE');
Add(-2146696960,'INET_E_CODE_DOWNLOAD_DECLINED');
Add(-2146695936,'INET_E_CODE_INSTALL_BLOCKED_BY_HASH_POLICY');
Add(-2146696192,'INET_E_CODE_INSTALL_SUPPRESSED');
Add(-2146697205,'INET_E_CONNECTION_TIMEOUT');
Add(-2146697209,'INET_E_DATA_NOT_AVAILABLE');
Add(-2146697208,'INET_E_DOWNLOAD_FAILURE');
Add(-2146697191,'INET_E_INVALID_CERTIFICATE');
Add(-2146697204,'INET_E_INVALID_REQUEST');
Add(-2146697214,'INET_E_INVALID_URL');
Add(-2146697213,'INET_E_NO_SESSION');
Add(-2146697206,'INET_E_NO_VALID_MEDIA');
Add(-2146697210,'INET_E_OBJECT_NOT_FOUND');
Add(-2146697196,'INET_E_REDIRECT_FAILED');
Add(-2146697195,'INET_E_REDIRECT_TO_DIR');
Add(-2146697196,'INET_E_REDIRECTING');
Add(-2146697211,'INET_E_RESOURCE_NOT_FOUND');
Add(-2146696704,'INET_E_RESULT_DISPATCHED');
Add(-2146697202,'INET_E_SECURITY_PROBLEM');
Add(-2146697192,'INET_E_TERMINATED_BIND');
Add(-2146697203,'INET_E_UNKNOWN_PROTOCOL');
Add(-2146697193,'INET_E_USE_EXTEND_BINDING');
end;

function TListStatusCodeMsg.Find(Code : Integer): String;
var i : integer;
begin
result := 'Code Inconnu';
for i := 0 to Count-1
do if Items[i].value = Code
   then begin
        result := Items[i].Msg;
        break;
        end;
end;

function ExtractParam(Params : string; Index : integer) : String;
var i, paramNr : integer;
begin
result := ''; ParamNr :=1;
for i := 1 to length(Params)
do begin
   if Params[i] = SprPr then begin Inc(ParamNr); continue; end;
   if Index = ParamNr then result := result + Params[i];
   end;
end;

procedure ProcessMessages();
var msg : TMSG;
begin
while (PeekMessage(Msg,0,0,0,PM_REMOVE))
do begin
   TranslateMessage(msg);
   DispatchMessage(msg);
   end;
end;

// function permettant de convertir un String en Pchar
function StringToPchar(MyString : String) : Pchar;
begin
    strPLcopy(@AStringToPchar,Pchar(MyString),length(MyString));
    result := @AStringToPchar;
end;

function PCharToString(Str: PChar): String;
var I: Integer;
    S: String;
begin
  I := 0; S := '';
  while I < 256
  do begin
     if Str[I] = #0
     then Break else S := S + Str[I];
     Inc(I);
     end;
  Result := S;
end;

// procedure utilise pour recevoir les informations demandes a Super macro
// Sendmessage(SmacroHandle, WM_LIST_ORDER, LibraryHandle, ...);
procedure GetListOrder(Order, params : PChar; correct : boolean); StdCall;
begin
GetListOrder_Order := Order;
GetListOrder_Param := params;
end;

function GetTypeVar(Name : String) : String;
var max, i : integer;
begin
result := 'NoType'; // Alpha ou Numerique
Sendmessage(SmacroHandle, WM_PLUGIN_MSG, LibraryHandle, PLUGIN_GET_VARIABLE_COUNT);
max := SMacroIntegerValue;
for i := 1 to max
do begin
   SendMessage(SmacroHandle, WM_PLUGIN_MSG, LibraryHandle, PLUGIN_GET_VAR_NAME + i);
   if SMacroStrValue = Name
   then begin
        Sendmessage(SmacroHandle, WM_PLUGIN_MSG, LibraryHandle, PLUGIN_GET_VAR_TYPE + i);
        result := SMacroStrValue;
        break;
        end;
   end;
end;


// exemple de procedure permettant de recevoir dans un ComboBox, ListBox, etc  de
// lui affecter les nom des variables stockes dans la macro courante

procedure GetListVar(Alpha, Numerique : Boolean; IDC : cardinal);
var i, max : integer;
    hWndDeviceList : HWND;
begin
hWndDeviceList := GetDlgItem( g_hDlg, IDC);

Sendmessage(SmacroHandle, WM_PLUGIN_MSG, LibraryHandle, PLUGIN_GET_VARIABLE_COUNT);
max := SMacroIntegerValue;
for i := 1 to max
do begin
   Sendmessage(SmacroHandle, WM_PLUGIN_MSG, LibraryHandle, PLUGIN_GET_VAR_TYPE + i);
   if (SMacroStrValue = 'Alpha') and (Alpha = True)
   then begin
        SendMessage(SmacroHandle, WM_PLUGIN_MSG, LibraryHandle, PLUGIN_GET_VAR_NAME + i);
        SendMessage( hWndDeviceList, CB_ADDSTRING, 0, LPARAM(PChar(SMacroStrValue)));
        end;
   if (SMacroStrValue = 'Numerique') and (Numerique = True)
   then begin
        SendMessage(SmacroHandle, WM_PLUGIN_MSG, LibraryHandle, PLUGIN_GET_VAR_NAME + i);
        SendMessage( hWndDeviceList, CB_ADDSTRING, 0, LPARAM(PChar(SMacroStrValue)));
        end;
   end;
end;

procedure GetListVarSpl(Alpha, Numerique : Boolean; IDC : cardinal);
var i, max : integer;
    hWndDeviceList : HWND;
    id : integer;
begin
hWndDeviceList := GetDlgItem( g_hDlg, IDC);
id := length(ListTagId);
if id < 0 then id := 0;
Sendmessage(SmacroHandle, WM_PLUGIN_MSG, LibraryHandle, PLUGIN_GET_VARIABLE_COUNT);
max := SMacroIntegerValue;
for i := 1 to max
do begin
   Sendmessage(SmacroHandle, WM_PLUGIN_MSG, LibraryHandle, PLUGIN_GET_VAR_TYPE + i);
   if (SMacroStrValue = 'Alpha') and (Alpha = True)
   then begin
        SendMessage(SmacroHandle, WM_PLUGIN_MSG, LibraryHandle, PLUGIN_GET_VAR_NAME + i);
        SendMessage( hWndDeviceList, LB_ADDSTRING, 0, LPARAM(PChar(SMacroStrValue)));
        Setlength(ListTagId,length(ListTagId)+1);
        ListTagId[length(ListTagId)-1] := id-1;
        end;
   if (SMacroStrValue = 'Numerique') and (Numerique = True)
   then begin
        SendMessage(SmacroHandle, WM_PLUGIN_MSG, LibraryHandle, PLUGIN_GET_VAR_NAME + i);
        SendMessage( hWndDeviceList, LB_ADDSTRING, 0, LPARAM(PChar(SMacroStrValue)));
        Setlength(ListTagId,length(ListTagId)+1);
        ListTagId[length(ListTagId)-1] := id-1;
        end;
   end;
end;

function GetValueOfVar(VarName : PChar) : string;
begin
Sendmessage(SmacroHandle, GET_VAR_VALUE, LibraryHandle, integer(VarName));
result := SMacroStrValue;
end;

Procedure SetValueOfVar(VarName, Value : PChar);
begin
Sendmessage(SmacroHandle, SET_VAR_VALUE, integer(VarName), integer(Value));
end;

function GetParam(index : integer) : String;
begin
Sendmessage(SmacroHandle, WM_PLUGIN_MSG, LibraryHandle, PLUGIN_GET_PARAM + index);
result := SMacroStrValue;
end;

function GetParamWithValue(index : integer) : String;
begin
Sendmessage(SmacroHandle, WM_PLUGIN_MSG, LibraryHandle, PLUGIN_GET_PARAM + index);
result := GetValueOfVar(Pchar(SMacroStrValue));
end;


procedure setCursor(HForm:integer; lpCursorName:PAnsiChar);
var hCur:integer;
    hWndDev : HWND;
    i : integer;
begin
hCur:=LoadCursor(0, lpCursorName);
try
SetClassLong(HForm, GCL_HCURSOR, hCur);

for I := 10 to 14
do begin
   hWndDev := GetDlgItem(g_hDlg, i);
   SetClassLong(hWndDev, GCL_HCURSOR, hCur)
   end;

for I := 20 to 23
do begin
   hWndDev := GetDlgItem(g_hDlg, i);
   SetClassLong(hWndDev, GCL_HCURSOR, hCur)
   end;

finally DestroyCursor(hCur); end;
end;


function DocToFrame(hDlg : HWND) : Variant;
var buff : array[1..255]of char;
    FrameName : Variant;
    j : integer;
begin
GetDlgItemText(hDlg,IDC_FRAME,@buff,255);
resultParam := PcharToString(@buff);
if (resultParam = '#NOFRAME') or (resultParam = '')
then result := tmpIEAPP.document
else begin
     if Copy(resultParam,1,7) = '#NONAME'
     then begin
          j := StrToInt(Copy(resultParam,8,1))-1;
          Result := tmpIEApp.Document.frames.Item(j).document;
          end
     else begin
          FrameName := resultParam;
          Result := tmpIEApp.Document.frames.Item(FrameName,0).document;
          end;
     end;
end;

procedure DrawEvidenceElement(Doc,DocCel : Variant; DocInd : integer);
var Element : Variant;
    buff : array[1..255]of char;
    ObjType : String;
    OldStyleBorderWidth,
    OldStyleBorderColor,
    OldStyleBorderStyle : Variant;
    i : integer;
begin
if IsDlgButtonchecked(g_hDlg,IDC_SHOW) = 0 then exit;

GetDlgItemText(g_hDlg,IDC_TypeObj,@buff,255);
ObjType := PcharToString(@buff);
if ObjType = 'Aucun' then exit;
if ObjType = 'script' then exit;
if ObjType = 'file' then exit;
if ObjType = 'hidden' then exit;
if ObjType = 'Php Var' then exit;
if ObjType = 'source' then exit;

if (ObjType = 'button') or (ObjType = 'checkbox') or (ObjType = 'image')  or (ObjType = 'password') or (ObjType = 'radio') or
   (ObjType = 'reset') or (ObjType = 'submit') or (ObjType = 'select') or (ObjType = 'text') or (ObjType = 'textarea')
then begin
     if DocCel = 'NoName'
     then Element := Doc.all.item(DocInd)
     else Element := Doc.all.item(DocCel,DocInd);
     end;

if (ObjType = 'link')
then begin
     for i := 0 to Doc.links.length-1
     do if Doc.links.item(i).outerText = DocCel
        then begin
             Element := Doc.links.item(i);
             break
             end;
     end;


//if Element.tagname = 'INPUT'
//then begin
     if ObjType <> 'image'
     then begin
          Element.setActive;
          Element.focus;
          end;

     //OldStyleBorderWidth := Element.style.BorderWidth;
     //OldStyleBorderColor := Element.style.BorderColor;
     //OldStyleBorderStyle := Element.style.BorderStyle;
     //Element.style.BorderWidth := 10;
     //Element.style.BorderColor := '#FF3300';
     //Element.style.BorderStyle := 'inset';
     Element.style.zoom := 2;
     for i := 0 to 100
     do begin
        sleepEx(10,False);
        ProcessMessages();
        end;

     //Element.style.BorderWidth := OldStyleBorderWidth;
     //Element.style.BorderColor := OldStyleBorderColor;
     //Element.style.BorderStyle := OldStyleBorderStyle;
     Element.style.zoom := 1;
//     end;
end;

procedure LoadElementFormObj(Doc : Variant; SelType : String);
var TagName,tmp : string;
    i,j,id, max : integer;
    hWndDeviceList : HWND;
    buff : array[1..255]of char;
    input : string;
begin
hWndDeviceList := GetDlgItem(g_hDlg, IDC_LIST);
if SelType <> 'link'
then begin
for i := 0 to Doc.all.length-1
do begin
   TagName := Doc.all.item(i).tagname;
   if (SelType = 'select') and ( TagName = 'SELECT')
   then begin
        input := Doc.all.item(i).name;
        if input = '' then continue;
        SendMessage( hWndDeviceList, LB_ADDSTRING, 0, LPARAM(PChar(input)));
        Setlength(ListTagId,length(ListTagId)+1);

        id := 0;
        for j := 0 to SendMessage( hWndDeviceList, LB_GETCOUNT, 0,0)
        do begin
           SendMessage( hWndDeviceList, LB_GETTEXT, j, integer(@buff));
           if PcharToString(@buff) = input then Inc(id);
           end;

        ListTagId[length(ListTagId)-1] := id-1;  // avant i

        SetLength(ListSelect,length(ListSelect)+1);
        max := Doc.all.item(i).options.length;
        SetLength(ListSelect[length(ListSelect)-1].Value,max);
        for j := 0 to Doc.all.item(i).options.length-1
        do ListSelect[length(ListSelect)-1].Value[j] := Doc.all.item(i).options.item(j).Text;
        continue;
        end;

   if (SelType = 'textarea') and (TagName = 'TEXTAREA')
   then begin
        input := Doc.all.item(i).name;
        if input = '' then continue;
        SendMessage( hWndDeviceList, LB_ADDSTRING, 0, LPARAM(PChar(input)));
        Setlength(ListTagId,length(ListTagId)+1);

        id := 0;
        for j := 0 to SendMessage( hWndDeviceList, LB_GETCOUNT, 0,0)
        do begin
           SendMessage( hWndDeviceList, LB_GETTEXT, j, integer(@buff));
           if PcharToString(@buff) = input then Inc(id);
           end;

        ListTagId[length(ListTagId)-1] := id-1;
        continue;
        end;


   if TagName = 'INPUT'
   then begin
        input := Doc.all.item(i).name;
        if input = '' then input := 'NoName';
        if seltype = Doc.all.item(i).type
        then begin
             SendMessage( hWndDeviceList, LB_ADDSTRING, 0, LPARAM(PChar(input)));
             Setlength(ListTagId,length(ListTagId)+1);

             id := 0;
             for j := 0 to SendMessage( hWndDeviceList, LB_GETCOUNT, 0,0)
             do begin
                SendMessage( hWndDeviceList, LB_GETTEXT, j, integer(@buff));
                if PcharToString(@buff) = input then Inc(id);
                end;
             ListTagId[length(ListTagId)-1] := id-1;
             end;
        end;
   end;
GetListVarspl(True, True, IDC_LIST);
end;

if SelType = 'link'
then begin
     for i := 0 to Doc.links.length-1
     do begin
        input := Doc.links.item(i).outerText;
        if input = '' then continue;

        SendMessage( hWndDeviceList, LB_ADDSTRING, 0, LPARAM(PChar(input)));
        Setlength(ListTagId,length(ListTagId)+1);

        id := 0;
        for j := 0 to SendMessage( hWndDeviceList, LB_GETCOUNT, 0,0)
        do begin
           SendMessage( hWndDeviceList, LB_GETTEXT, j, integer(@buff));
           if PcharToString(@buff) = input then Inc(id);
           end;
        ListTagId[length(ListTagId)-1] := id-1;
        end;
     end;

if SelType = 'script'
then begin
     for i := 0 to Doc.scripts.length-1
     do begin
        input := Doc.scripts.item(i).language;
        if input = '' then continue;

        SendMessage( hWndDeviceList, LB_ADDSTRING, 0, LPARAM(PChar(input)));
        Setlength(ListTagId,length(ListTagId)+1);

        id := 0;
        for j := 0 to SendMessage( hWndDeviceList, LB_GETCOUNT, 0,0)
        do begin
           SendMessage( hWndDeviceList, LB_GETTEXT, j, integer(@buff));
           if PcharToString(@buff) = input then Inc(id);
           end;
        ListTagId[length(ListTagId)-1] := id-1;
        end;
     end;
end;


procedure LoadInputForm(hDlg : HWND; ReloadFrameList : Boolean);
var i,j,k,x,y, max, id : integer;
    buff : array[1..255]of char;
    hWndDeviceList : HWND;
    input : string;
    seltype, TagName,tmp : string;
    Doc : Variant;
    Visible : boolean;
begin
if IsDlgButtonchecked(hDlg,IDC_SHOW) = 0
then Visible := False
else Visible := True;

hWndDeviceList := GetDlgItem(g_hDlg, IDC_LIST);
SendMessage( hWndDeviceList, LB_RESETCONTENT,0,0);

SendMessage( hWndDeviceList, LB_ADDSTRING, 0, LPARAM(PChar('Chargement en cours ...')));
SetCursor(hDlg,IDC_WAIT);
Processmessages;
try

if VarIsClear(tmpIEApp) or VarIsNull(tmpIEApp)
then begin tmpIEApp := CreateOleObject('InternetExplorer.Application'); end;
try
tmpIEApp.Visible:=Visible;
except tmpIEApp := CreateOleObject('InternetExplorer.Application'); tmpIEApp.Visible:=Visible; end;

// chargement de la page web
GetDlgItemText(hDlg,IDC_EDIT,@buff,255);
resultParam := PcharToString(@buff);
if tmpIEApp.LocationURL <> resultParam
then tmpIEApp.Navigate(resultParam);

while TmpIEApp.ReadyState <> 4
do begin
     sleepEx(100,False);
     ProcessMessages();
   end;

// recheche de frames
GetDlgItemText(hDlg,IDC_FRAME,@buff,255);
resultParam := PcharToString(@buff);
if ReloadFrameList = True
then begin
     j := 0;
     hWndDeviceList := GetDlgItem(g_hDlg, IDC_FRAME);
     SendMessage( hWndDeviceList, CB_RESETCONTENT,0,0);
     SendMessage( hWndDeviceList, CB_ADDSTRING, 0, LPARAM(Pchar('#NOFRAME')));
     for i := 0 to tmpIEApp.Document.frames.length-1
     do begin
        try
        input := tmpIEApp.Document.frames.item(i).name;
        except begin
               input := '#NOACCESPERMITTED'+IntToStr(i+1);
               SendMessage( hWndDeviceList, CB_ADDSTRING, 0, LPARAM(PChar(input)));
               continue;
               end;
        end;
        if input = '' then begin Inc(j); input := '#NONAME'+IntToStr(i+1); end;
        SendMessage( hWndDeviceList, CB_ADDSTRING, 0, LPARAM(PChar(input)));
        end;
     SetDlgItemText(g_hDlg,IDC_Frame,Pchar('#NOFRAME'));
     end;



// recherche du tag selectionn
hWndDeviceList := GetDlgItem(g_hDlg, IDC_LIST);
GetDlgItemText(hDlg,IDC_TypeObj,@buff,255);

SelType := PcharToString(@buff);

SendMessage( hWndDeviceList, LB_RESETCONTENT,0,0);

Doc := DocToFrame(hdlg);

if VarIsClear(Doc) or VarIsNull(Doc)
then exit;


Setlength(ListTagId,0);
SetLength(ListSelect,0);

LoadElementFormObj(Doc,SelType);
{for i := 0 to Doc.all.tags('table').length -1
do begin
   for j := 0 to Doc.all.tags('table').item(i).Rows.length-1
   do for k := 0 to Doc.all.tags('table').item(i).Rows.item(j).Cells.length-1
      do LoadElementFormObj(Doc.all.tags('table').item(i).Rows.item(j).Cells.item(k),SelType);
   end;
}

if SelType = 'Php Var'
then begin
     tmp := VarToStr(TmpIEApp.Document.URL);
     y := 0;
     for x := 0 to length(tmp)-1
     do begin
        if tmp[x]='?' then y := x;
        if tmp[x]='='
        then begin
             SendMessage( hWndDeviceList, LB_ADDSTRING, 0, LPARAM(PChar(Copy(tmp,y+1,x-y-1))));
             //
             input := PChar(Copy(tmp,y+1,x-y-1));
             Setlength(ListTagId,length(ListTagId)+1);
             id := 0;
             for j := 0 to SendMessage( hWndDeviceList, LB_GETCOUNT, 0,0)
             do begin
                SendMessage( hWndDeviceList, LB_GETTEXT, j, integer(@buff));
                if PcharToString(@buff) = input then Inc(id);
                end;
             ListTagId[length(ListTagId)-1] := id-1;
             //
             end;
     end;

     end;

if SelType = 'source'
then begin
     tmp := VarToStr(TmpIEApp.Document.body.innerText);
     SetDlgItemText(g_hDlg,IDC_LABEL6,Pchar(VarToStr(TmpIEApp.Document.body.innerHTML)));
     SendMessage( hWndDeviceList, LB_ADDSTRING, 0, LPARAM(PChar('innerHTML')));
     SendMessage( hWndDeviceList, LB_ADDSTRING, 0, LPARAM(PChar('innerText')));
     Setlength(ListTagId,2);
     ListTagId[0] := 1;
     ListTagId[1] := 1;
     end;

hWndDeviceList := GetDlgItem(g_hDlg, IDC_LIST);
SendMessage( hWndDeviceList, LB_SETCURSEL,0, 0);
SetDlgItemText(g_hDlg,IDC_TAGID,'1');

hWndDeviceList := GetDlgItem(g_hDlg, IDC_COMBOBOX);
SendMessage( hWndDeviceList, CB_RESETCONTENT,0,0);
GetListVar(True, True, IDC_COMBOBOX);

if (SelType = 'select') and (length(ListSelect)>0)
then begin
     for i := 0 to length(ListSelect[0].value)-1
     do SendMessage( hWndDeviceList, CB_ADDSTRING,0,LPARAM(PChar(ListSelect[0].Value[i])));
     end;

finally SetCursor(hDlg,IDC_ARROW); end;
end;

procedure OnInitObjets;
var hWndDeviceList : HWND;
    index : integer;
    buff : array[1..255]of char;
begin
hWndDeviceList := GetDlgItem(g_hDlg, IDC_TypeObj);
SendMessage( hWndDeviceList, CB_RESETCONTENT,0,0);
for index := 0 to length(TagList)-1
do SendMessage( hWndDeviceList, CB_ADDSTRING, 0, LPARAM(PChar(TagList[index])));

SetDlgItemText(g_hDlg,IDC_TypeObj,'text');

hWndDeviceList := GetDlgItem(g_hDlg, IDC_FRAME);
SendMessage( hWndDeviceList, CB_RESETCONTENT,0,0);
hWndDeviceList := GetDlgItem(g_hDlg, IDC_COMBOBOX);
SendMessage( hWndDeviceList, CB_RESETCONTENT,0,0);
GetListVar(True, False, IDC_EDIT);
GetListVar(True, True, IDC_COMBOBOX);

hWndDeviceList := GetDlgItem(g_hDlg, IDC_LIST);
SendMessage( hWndDeviceList, LB_RESETCONTENT,0,0);

if resultparam = ''
then begin
     SetDlgItemText(g_hDlg,IDC_EDIT,'http://www.');
     SetDlgItemText(g_hDlg,IDC_LIST,'');
     SetDlgItemText(g_hDlg,IDC_COMBOBOX,'');
     SetDlgItemText(g_hDlg,IDC_TAGID,'0');
     SetDlgItemText(g_hDlg,IDC_TypeObj,'text');
     SetDlgItemText(g_hDlg,IDC_Frame,'#NOFRAME');
     end
else begin
     SetDlgItemText(g_hDlg,IDC_EDIT,PChar(GetParam(1))); // url
     SetDlgItemText(g_hDlg,IDC_TAGID,PChar(GetParam(4)));
     SetDlgItemText(g_hDlg,IDC_TypeObj,PChar(GetParam(5)));
     SetDlgItemText(g_hDlg,IDC_Frame,PChar(GetParam(6)));
     LoadInputForm(g_hDlg,True);
     SetDlgItemText(g_hDlg,IDC_COMBOBOX,PChar(GetParam(3)));
     hWndDeviceList := GetDlgItem(g_hDlg, IDC_LIST);
     for index := 0 to length(ListTagId)-1
     do begin
        SendMessage( hWndDeviceList, LB_GETTEXT, index, integer(@buff));
        if (ListTagID[index] = StrToInt(GetParam(4))) and (GetParam(2) = PcharToString(@buff))
        then begin
             SendMessage( hWndDeviceList, LB_SETCURSEL,index, 0);
             break;
             end;
        end;
     end;

end;


function InfoDlgProc( hDlg : HWND; amessage : UINT; wParm : WPARAM; lParm : LPARAM ) : Boolean; stdcall;
var buff : array[1..255]of char;
    hWndDeviceList : HWND;
    pos, i, index : integer;
    Doc,DocCel : Variant;
    DocInd : Integer;
begin
  case (amessage) of
    WM_INITDIALOG:
    begin
    g_hDlg := hDlg; // Slction du HWND global
    SetWindowPos(g_hDlg, HWND_TOPMOST,0,0,0,0,SWP_NOMOVE or SWP_NOSIZE);
    OnInitObjets;
    result := true;
    end;
    WM_SIZE, WM_MOVE, WM_ACTIVATE:
                begin
                InvalidateRect(HDlg, nil, False);
                result := True;
                end;

    WM_WINDOWPOSCHANGED :
                begin
                SetWindowPos(g_hDlg, HWND_TOPMOST,0,0,0,0,SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE);
                result := True;
                end;
    WM_DESTROY : begin try tmpIEApp.Quit; tmpIEApp := Unassigned; except end; end;
    WM_COMMAND:
    begin
        case LOWORD(wParm) of
        IDC_GO     : begin
                           LoadInputForm(hDlg,True);
                           InvalidateRect(HDlg, nil, False);
                           result := True;
                     end;
        IDC_BOUTON1, IDC_BOUTON3
                         : begin
                           resultParam := '';
                           GetDlgItemText(hDlg,IDC_EDIT,@buff,255);
                           resultParam := resultParam + PcharToString(@buff) + SprPr;


                           hWndDeviceList := GetDlgItem(g_hDlg, IDC_LIST);
                           pos := SendMessage( hWndDeviceList, LB_GETCURSEL,0, 0);
                           SendMessage( hWndDeviceList, LB_GETTEXT, pos, integer(@buff));
                           resultParam := resultParam + PcharToString(@buff) + SprPr;

                           GetDlgItemText(hDlg,IDC_COMBOBOX,@buff,255);
                           resultParam := resultParam + PcharToString(@buff) + SprPr;
                           GetDlgItemText(hDlg,IDC_TAGID,@buff,255);
                           resultParam := resultParam + PcharToString(@buff) + SprPr;
                           GetDlgItemText(hDlg,IDC_TypeObj,@buff,255);
                           resultParam := resultParam + PcharToString(@buff) + SprPr;
                           GetDlgItemText(hDlg,IDC_Frame,@buff,255);
                           resultParam := resultParam + PcharToString(@buff) + SprPr;
                           if IsDlgButtonchecked(hDlg,IDC_SHOW) = 0
                           then resultParam := resultParam + '0' + SprPr
                           else resultParam := resultParam + '1' + SprPr;

                           if LOWORD(wParm) = IDC_BOUTON1
                           then begin
                                EndDialog(hDlg, IDC_BOUTON1);
                                end;
                           if LOWORD(wParm) = IDC_BOUTON3
                           then Sendmessage(SmacroHandle, WM_ADD_ORDER , LibraryHandle,integer(resultParam));
                           result := True;
                     end;
        IDC_BOUTON2,
        IDCANCEL  : begin Sendmessage(SmacroHandle, WM_PLUGIN_MSG , LibraryHandle, PLUGIN_CANCEL_NEW_OR_CHANGE_ORDER);
                           EndDialog(hDlg, IDC_BOUTON2);
                           result := True;
                     end;
        IDC_Frame: begin // changement du type de composant
                        case HIWORD(wParm) of CBN_SELENDOK  :
                             begin
                             hWndDeviceList := GetDlgItem(g_hDlg, IDC_Frame);
                             index := SendMessage(hWndDeviceList, CB_GETCURSEL, 0,0);
                             SendMessage(hWndDeviceList,CB_GETLBTEXT,index,integer(@buff));
                             resultParam := PcharToString(@buff);
                             if Copy(ResultParam,1,17) = '#NOACCESPERMITTED'
                             then begin
                                  resultParam := '#NOFRAME';
                                  windows.MessageBox(hDlg,'Le site refuse l''accs  cette frame.','Avertissement',0);
                                  end;

                             SetDlgItemText(hDlg,IDC_Frame,Pchar(resultParam));
                             processmessages;
                             LoadInputForm(g_hDlg,False);
                             //InvalidateRect(HDlg, nil, False);
                             SendMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDC_LIST,CBN_SELCHANGE),0);
                             result := true;
                             end;
                        else result := False;
                      end
                  end;
        IDC_TypeObj: begin // changement du type de composant
                        case HIWORD(wParm) of CBN_EDITCHANGE:
                             begin
                             processmessages;
                             InvalidateRect(HDlg, nil, False);
                             LoadInputForm(g_hDlg,False);
                             result := false;
                             end;
                             CBN_SELCHANGE :
                             begin
                             hWndDeviceList := GetDlgItem(g_hDlg, IDC_TypeObj);
                             index := SendMessage(hWndDeviceList, CB_GETCURSEL, 0,0);
                             SetDlgItemText(hDlg,IDC_TypeObj,Pchar(TagList[index]));
                             LoadInputForm(g_hDlg,False);
                             InvalidateRect(HDlg, nil, False);
                             result := false;
                             SendMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDC_LIST,CBN_SELCHANGE),0);
                             end;
                        else result := False;
                      end
                  end;
        IDC_LIST: begin
                        case HIWORD(wParm) of LBN_SELCHANGE  :
                             begin
                             Doc := DocToFrame(hDlg);
                             SetDlgItemText(g_hDlg,IDC_LABEL6,'');
                             ProcessMessages;
                             InvalidateRect(HDlg, nil, False);
                             hWndDeviceList := GetDlgItem(g_hDlg, IDC_LIST);
                             index := SendMessage(hWndDeviceList, LB_GETCURSEL, 0,0);
                             if index = LB_ERR then begin result := False; Exit; end;// vite les bloquages si aucun lment n'est slectionn.
                             SendMessage( hWndDeviceList, LB_GETTEXT, index, integer(@buff));
                             DocCel := PcharToString(@buff);

                             SetDlgItemText(g_hDlg,IDC_TAGID,Pchar(IntToStr(ListTagid[index])));
                             DocInd := ListTagid[index]-1;

                             DrawEvidenceElement(Doc,DocCel,DocInd);

                             hWndDeviceList := GetDlgItem(g_hDlg, IDC_COMBOBOX);
                             SendMessage( hWndDeviceList, CB_RESETCONTENT,0,0);
                             GetListVar(True, True, IDC_COMBOBOX);


                             if GetTypeVar(PcharToString(@buff)) <> 'NoType'
                             then begin
                                  SetDlgItemText(g_hDlg,IDC_LABEL6,'Variable slectionne, resultat imprvisible.');
                                  result := True;
                                  Exit;
                                  end;

                             GetDlgItemText(hDlg,IDC_TypeObj,@buff,255);
                             if PcharToString(@buff) = 'source'
                             then begin
                                  hWndDeviceList := GetDlgItem(g_hDlg, IDC_LIST);
                                  index := SendMessage(hWndDeviceList, LB_GETCURSEL, 0,0);
                                  if index = 0 then SetDlgItemText(g_hDlg,IDC_LABEL6,Pchar(VarToStr(Doc.body.innerHTML)));
                                  if index = 1 then SetDlgItemText(g_hDlg,IDC_LABEL6,Pchar(VarToStr(Doc.body.innerText)));
                                  end;
                             if PcharToString(@buff) = 'link'
                             then begin
                                  hWndDeviceList := GetDlgItem(g_hDlg, IDC_LIST);
                                  index := SendMessage(hWndDeviceList, LB_GETCURSEL, 0,0);
                                  SetDlgItemText(g_hDlg,IDC_COMBOBOX,'Click');
                                  SetDlgItemText(g_hDlg,IDC_LABEL6,Pchar(VarToStr(Doc.links.item(index).href)));
                                  end;
                             if PcharToString(@buff) = 'select'
                             then begin
                                  for i := 0 to length(ListSelect[index].value)-1
                                  do SendMessage( hWndDeviceList, CB_ADDSTRING,0,LPARAM(PChar(ListSelect[index].Value[i])));
                                  end;
                             InvalidateRect(HDlg, nil, False);
                             end;
                        else result := False;
                        end;
                  end;
      else result := False;
      end;
    end;
    else result := False;
  end;
end;


{***********************************************************************************************************}
{                    Voici les procdure obligatoire pour que Super macro accepte votre dll                 }
{***********************************************************************************************************}

// procedure utilise pour recevoir les information demandes a Super macro
// Sendmessage(SmacroHandle, WM_PLUGIN_MSG, LibraryHandle, ...);
// Suivant le type d'info le resultat est stock dans PcharValue ou IntegerValue
// Si la demande est correct le paramtre correct est a true sinon false
procedure GetInfoFromSMacro(Info, PcharValue : PChar; IntegerValue : integer ;correct : boolean); StdCall;
begin
SMacroInfo := Info;
SMacroPcharValue := PcharValue;
SMacroStrValue := PcharValue; // mme valeur que SMacroPcharValue mais au format string
SMacroIntegerValue := IntegerValue;
SMacroInfoCorrect := correct;
end;

// reoit sont propre handle utile pour le parametre wparam de SendMessage
procedure ReceiveHandleLibrary(Handle : hwnd); StdCall;
begin LibraryHandle := Handle; end;

// reoit le handle de l'application appell utile pour le parametre Hwnd de SendMessage
procedure ReceiveHandleApp(Handle : hwnd); StdCall;
begin SmacroHandle := Handle; end;

// nom de la commande
function GetInfoName() : PChar ; StdCall;
begin result := 'IEForm'; end;

// nom de la rubrique o placer la commande (si elle n'existe pas elle est crer automatiquement par Super macro)
function GetInfoRubrique() : PChar ; StdCall;
begin result := 'Internet'; end;

// info bulle de la commande
function GetInfoHint() : PChar ; StdCall;
begin result := 'Remplissage d''un formulaire Web'; end;

// description de la commande
function GetInfoDescription() : PChar ; StdCall;
begin result := 'IEForm.txt' end;

// handle de l'icone de la commande
function GetInfoIcon() : hIcon ; StdCall;
begin
result := LoadIcon(hinstance,'MAINICON'); // rcupere l'icon qui se trouve dans le fichier ressource de la dll
end;
// *** End of informations of New Order *** //


// construction de la form et de ses composants
function ShowForm(Params : Pchar) : String; StdCall;
begin

Sendmessage(SmacroHandle, WM_PLUGIN_MSG, LibraryHandle, PLUGIN_GET_CHAR_SEPARATION);
SprPr := SMacroStrValue;

resultParam := Params;
DialogBox(hInstance,MAKEINTRESOURCE(IDD_FENETRE), GetDesktopWindow, @InfoDlgProc );
result := resultParam;
end;

// *** Standard function and procedure *** //

// test si les paramtres de la commande est valide, a vous de dterminer les conditions de validit
function Debug(Params : Pchar) : Boolean; StdCall;
var prm3, prm5 : string;
begin
result := True;
prm5 := ExtractParam(Params,5);
prm3 := ExtractParam(Params,3);
if (prm5 = 'source') and (prm3 = '')
then result := False;
end;

// posibilit d'afficher un message dans le control des commandes
// attention si vous renvoyez False dans Debug l'icone du message sera celui de l'erreur
// sinon l'icone du message sera un warning
function MsgDebug(Params : Pchar) : PChar; StdCall;
var dwFlags : DWORD;
    prm3, prm5 : string;
begin
//result := Pchar('Pas de contrl sur cette commande.');
result := '';
dwFlags := INTERNET_CONNECTION_MODEM + INTERNET_CONNECTION_LAN + INTERNET_CONNECTION_PROXY ;
if InternetGetConnectedState(@dwFlags,0)= False
then result := 'Attention l''utilisation de cette commande sans connexion internet provoquera fatalement une erreur.';
prm5 := ExtractParam(Params,5);
prm3 := ExtractParam(Params,3);
if (prm5 = 'source') and (prm3 = '')
then result := 'Veuillez placer un nom de fichier pour la sauvegarde de la source dans le paramtre "Valeur de remplacement".'

end;

// function retournant les paramtres de la nouvelle commande
function NewOrdre() : Pchar; StdCall;
begin
result := StringToPchar(ShowForm(nil));
end;

// function retournant les paramtres changs
function ChangeOrdre(Params : Pchar) : Pchar; StdCall;
begin
result := StringToPchar(ShowForm(Params));
end;

// procedure appele lorsque l'utilisateur clique sur le bouton stop de Super macro
procedure StopOrder(); StdCall;
begin
Stop := True;
end;


procedure TEventHandlers.NavigateError(Sender: TObject;const pDisp: IDispatch; var URL, Frame, StatusCode: OleVariant;var Cancel: WordBool);
var msg : String;
begin
msg := 'Erreur de navigation: '+ StatusCodeObj.Find(StatusCode)+'.';
Sendmessage(SmacroHandle,PLUGIN_ERROR_OF_EXECUTE, 10, Integer(Pchar(msg)));
end;

// procedure appele quand Super macro demande l'excution de votre commande
procedure ExecuteOrder(Params : Pchar); StdCall;
var cellule : Variant;
    index  : integer;
    tmp,valeur : string;
    AsText : Boolean;
    ObjType : String;
    i, j, x,y,z : integer;
    fichier : TextFile;
    URL : String;
    Doc,FrameName : Variant;
begin

Stop := False;
valeur := Pchar(GetParamWithValue(3));

if VarIsEmpty(IEApp)
then IEApp := CreateOleObject('InternetExplorer.Application');

try
IEApp.Visible := True;
except IEApp := CreateOleObject('InternetExplorer.Application'); IEApp.Visible := True; end;



URL := GetParamWithValue(1);
if URL <> ''
then if IEApp.LocationURL <> URL
     then begin
          if (StrIComp(Pchar(Copy(URL,1,5)), 'http:') = 0) or (StrIComp(Pchar(Copy(URL,1,6)), 'https:') = 0)
          then begin

               WebBrowserEvents.Connect (IUnknown (IEAPP));
               IEApp.Navigate(URL)
               end
          else Sendmessage(SmacroHandle,PLUGIN_ERROR_OF_EXECUTE, 0, Integer(Pchar('URL invalide ['+ URL +']')));
          end;

while (IEApp.ReadyState <> 4) and (Stop = False)
do begin
     sleepEx(500,True);
     ProcessMessages();
     end;

WebBrowserEvents.Disconnect;
if Stop = True then Exit;

cellule := GetParamwithvalue(2);

if cellule = 'NoName' then cellule := '';
index := StrToInt(GetParam(4))-1;
if index < 0 then index := 0;

try
ObjType := GetParam(5);
except Exit; end;
if ObjType = 'Aucun' then Exit;

// traitement sur frame
if (GetParam(6) = '') or (GetParam(6) = '#NOFRAME')
then Doc := IEApp.document
else begin
     if Copy(GetParam(6),1,7) = '#NONAME'
     then begin
          j := StrToInt(Copy(GetParam(6),8,1))-1;
          Doc := IEApp.Document.frames.Item(j).document;
          end
     else begin
          FrameName := resultParam;
          Doc := IEApp.Document.frames.Item(FrameName,0).document;
          end;
     end;



AsText := True;

if (ObjType = 'checkbox') or (ObjType = 'radio')
then begin
     IEApp.Visible:=True;
     if valeur = '1' then Doc.all.item(cellule, index).checked := True;
     if valeur = '0' then  Doc.item(cellule, index).checked := False;
     AsText := False;
     end;

if (ObjType = 'link')
then begin
     IEApp.Visible:=True;
     j := -1;
     for i := 0 to Doc.links.length-1
     do begin
        if Doc.links.item(i).outerText = cellule
        then begin
             Inc(j);
             if j = index
             then begin
                  if valeur = 'Click' then Doc.links.item(i).click;
                  Exit;
                 end;
              end;
        AsText := False;
        end;
     end;


if (ObjType = 'button') or (ObjType = 'submit') or
   (ObjType = 'image') or (ObjType = 'reset')
then begin
     IEApp.Visible:=True;
     if cellule = ''
     then begin
          j := -1;
          for i := 0 to Doc.all.length-1
          do if Doc.all.item(i).tagname = 'INPUT'
             then if Doc.all.item(i).type = ObjType
                  then begin
                       Inc(j);
                       if j = index
                       then begin
                            Doc.all.item(i).click;
                            Exit;
                            end;
                       end;
          end;
     if valeur = '1' then Doc.all.item(cellule, index).click;
     AsText := False;
     end;

if ObjType = 'select'
then begin
     IEApp.Visible:=True;
     for i := 0 to Doc.all.item(cellule, index).options.length-1
     do if Doc.all.item(cellule, index).options.item(i).Text = Valeur
        then Doc.all.item(cellule, index).value := Doc.all.item(cellule, index).options.item(i).value;
     AsText := False;
     end;

if ObjType = 'Php Var'
then begin
     IEApp.Visible:=True;
     tmp := VarToStr(IEApp.Document.URL);
     z := 0;
     for x := 0 to length(tmp)-1
     do begin
        y := 0; z := 0;
        if tmp[x]='?' then y := x;
        if tmp[x]='='
        then begin
             if Copy(tmp,y+1,x-y-1) = cellule
             then begin z := x; break; end;
             end;
     end;
     if z <> 0
     then for x := z to length(tmp)-1
          do if tmp[x] = '?' then break;

     tmp := Copy(tmp,z+1,x-z);
     valeur := Pchar(GetParam(3));
     SetValueOfVar(Pchar(Valeur),Pchar(tmp));
     AsText := False;
     end;

if ObjType = 'source'
then begin
     tmp := '';
     Sendmessage(SmacroHandle,PLUGIN_ERROR_OF_EXECUTE, 5, Integer(Pchar('Load :')+ cellule));
     try
     if cellule = 'innerHTML'
     then tmp := Pchar(VarToStr(Doc.body.innerHTML));
     if cellule = 'innerText'
     then tmp := Pchar(VarToStr(Doc.body.innerText));
     except Sendmessage(SmacroHandle,PLUGIN_ERROR_OF_EXECUTE, 2, Integer(Pchar('Impossible d''obtenir la source HTML.')));  end;
     assignFile(fichier,Valeur);
     try
     rewrite(fichier);
     try
     writeln(fichier,tmp);
     finally CloseFile(fichier); end;
     except on EInOutError
            do begin
               Sendmessage(SmacroHandle,PLUGIN_ERROR_OF_EXECUTE, 0, Integer(Pchar('Impossible de crer le fichier nomm '+ Valeur)));
               CloseFile(Fichier);
               end;
     end;
     AsText := False;
     IEApp.Quit;
     IEApp := Unassigned;
end;

if AsText = True
then begin
     IEApp.Visible:=True;
     if cellule = ''
     then begin
          j := -1;
          for i := 0 to Doc.all.length-1
          do if Doc.all.item(i).tagname = 'INPUT'
             then if Doc.all.item(i).type = ObjType
                  then begin
                       Inc(j);
                       if j = index then Doc.all.item(i).value := valeur;
                       Exit;
                       end;
          end;
     if VarIsClear(Doc.all.item(cellule, index)) = False
     then Doc.all.item(cellule, index).value := valeur;
     end;
WebBrowserEvents.Disconnect;
end;
// *** End of standards functions and procedures *** //

// export des functions et procedures obligatoires
Exports
ReceiveHandleApp     name 'ReceiveHandleApp',
ReceiveHandleLibrary name 'ReceiveHandleLibrary',
GetInfoFromSMacro    name 'GetInfoFromSMacro',
GetListOrder         name 'GetListOrder',
GetInfoName          name 'GetInfoName',
GetInfoRubrique      name 'GetInfoRubrique',
GetInfoHint          name 'GetInfoHint',
GetInfoDescription   name 'GetInfoDescription',
GetInfoIcon          name 'GetInfoIcon',
Debug                name 'Debug',
MsgDebug             name 'MsgDebug',
NewOrdre             name 'NewOrdre',
ChangeOrdre          name 'ChangeOrdre',
ExecuteOrder         name 'ExecuteOrder',
StopOrder            name 'StopOrder';

begin
tmpIEApp := Unassigned;
IEApp := Unassigned;
StatusCodeObj := TListStatusCodeMsg.create;
WebBrowserEvents := TDWebBrowserEvents2.Create(nil);
WebBrowserEvents.NavigateError := EvHandler.NavigateError;
end.
