{ *****************************************************************************
  WARNING: This component file was generated using the EventSinkImp utility.
           The contents of this file will be overwritten everytime EventSinkImp
           is asked to regenerate this sink component.

  NOTE:    When using this component at the same time with the XXX_TLB.pas in
           your Delphi projects, make sure you always put the XXX_TLB unit name
           AFTER this component unit name in the USES clause of the interface
           section of your unit; otherwise you will get interface conflict
           errors from the Delphi compiler.

           EventSinkImp is written by Binh Ly (bly@castle.net)
  *****************************************************************************
  //Sink Classes//
  TDWebBrowserEvents2
  TDWebBrowserEvents
  TDShellFolderViewEvents
  TDShellWindowsEvents
}

//SinkUnitName//
unit SHDocVwEvents;

interface

uses
  Windows,
  ActiveX,
  Classes,
  ComObj,
  OleCtrls
  //SinkUses//
  , StdVCL
  , SHDocVw_TLB
  ;

type
  { backward compatibility types }
  {$IFDEF VER100}
  OLE_COLOR = TOleColor;
  {$ENDIF}

  //SinkImportsForwards//

  //SinkImports//

  //SinkIntfStart//

  //SinkEventsForwards//
  TDWebBrowserEvents2StatusTextChangeEvent = procedure (Sender : TObject; const Text: WideString) of object;
  TDWebBrowserEvents2ProgressChangeEvent = procedure (Sender : TObject; Progress: Integer; ProgressMax: Integer) of object;
  TDWebBrowserEvents2CommandStateChangeEvent = procedure (Sender : TObject; Command: Integer; Enable: WordBool) of object;
  TDWebBrowserEvents2DownloadBeginEvent = procedure (Sender : TObject) of object;
  TDWebBrowserEvents2DownloadCompleteEvent = procedure (Sender : TObject) of object;
  TDWebBrowserEvents2TitleChangeEvent = procedure (Sender : TObject; const Text: WideString) of object;
  TDWebBrowserEvents2PropertyChangeEvent = procedure (Sender : TObject; const szProperty: WideString) of object;
  TDWebBrowserEvents2BeforeNavigate2Event = procedure (Sender : TObject; const pDisp: IDispatch; var URL: OleVariant; var Flags: OleVariant; var TargetFrameName: OleVariant; var PostData: OleVariant; var Headers: OleVariant; var Cancel: WordBool) of object;
  TDWebBrowserEvents2NewWindow2Event = procedure (Sender : TObject; var ppDisp: IDispatch; var Cancel: WordBool) of object;
  TDWebBrowserEvents2NavigateComplete2Event = procedure (Sender : TObject; const pDisp: IDispatch; var URL: OleVariant) of object;
  TDWebBrowserEvents2DocumentCompleteEvent = procedure (Sender : TObject; const pDisp: IDispatch; var URL: OleVariant) of object;
  TDWebBrowserEvents2OnQuitEvent = procedure (Sender : TObject) of object;
  TDWebBrowserEvents2OnVisibleEvent = procedure (Sender : TObject; Visible: WordBool) of object;
  TDWebBrowserEvents2OnToolBarEvent = procedure (Sender : TObject; ToolBar: WordBool) of object;
  TDWebBrowserEvents2OnMenuBarEvent = procedure (Sender : TObject; MenuBar: WordBool) of object;
  TDWebBrowserEvents2OnStatusBarEvent = procedure (Sender : TObject; StatusBar: WordBool) of object;
  TDWebBrowserEvents2OnFullScreenEvent = procedure (Sender : TObject; FullScreen: WordBool) of object;
  TDWebBrowserEvents2OnTheaterModeEvent = procedure (Sender : TObject; TheaterMode: WordBool) of object;
  TNavigateErrorEvent = procedure(Sender: TObject; const pDisp: IDispatch; var URL, Frame, StatusCode: OleVariant; var Cancel: WordBool) of object;

  //SinkComponent//
  TDWebBrowserEvents2 = class (TComponent, IUnknown, IDispatch
    //ISinkInterface//
  )
  protected
    { IDispatch }
    function GetIDsOfNames(const IID: TGUID; Names: Pointer;
      NameCount, LocaleID: Integer; DispIDs: Pointer): HResult; virtual; stdcall;
    function GetTypeInfo(Index, LocaleID: Integer; out TypeInfo): HResult; virtual; stdcall;
    function GetTypeInfoCount(out Count: Integer): HResult; virtual; stdcall;
    function Invoke(DispID: Integer; const IID: TGUID; LocaleID: Integer;
      Flags: Word; var Params; VarResult, ExcepInfo, ArgErr: Pointer): HResult; virtual; stdcall;

    { IUnknown }
    function QueryInterface(const IID: TGUID; out Obj): HResult; {$IFDEF VER120} override; {$ENDIF} stdcall;
    function _AddRef: Integer; stdcall;
    function _Release: Integer; stdcall;

    //ISinkInterfaceMethods//
  protected
    FCookie : integer;
    FCP : IConnectionPoint;
    FSinkIID : TGuid;
    FSource : IUnknown;
  public
    { system methods }
    constructor Create (pOwner : TComponent); override;
    destructor Destroy; override;
    procedure Connect (pSource : IUnknown);
    procedure Disconnect;
    property SinkIID : TGuid read FSinkIID;
    property Source : IUnknown read FSource;
  protected
    //SinkInterface//
    procedure DoStatusTextChange(const Text: WideString); safecall;
    procedure DoProgressChange(Progress: Integer; ProgressMax: Integer); safecall;
    procedure DoCommandStateChange(Command: Integer; Enable: WordBool); safecall;
    procedure DoDownloadBegin; safecall;
    procedure DoDownloadComplete; safecall;
    procedure DoTitleChange(const Text: WideString); safecall;
    procedure DoPropertyChange(const szProperty: WideString); safecall;
    procedure DoBeforeNavigate2(const pDisp: IDispatch; var URL: OleVariant; var Flags: OleVariant; var TargetFrameName: OleVariant; var PostData: OleVariant; var Headers: OleVariant; var Cancel: WordBool); safecall;
    procedure DoNewWindow2(var ppDisp: IDispatch; var Cancel: WordBool); safecall;
    procedure DoNavigateComplete2(const pDisp: IDispatch; var URL: OleVariant); safecall;
    procedure DoDocumentComplete(const pDisp: IDispatch; var URL: OleVariant); safecall;
    procedure DoOnQuit; safecall;
    procedure DoOnVisible(Visible: WordBool); safecall;
    procedure DoOnToolBar(ToolBar: WordBool); safecall;
    procedure DoOnMenuBar(MenuBar: WordBool); safecall;
    procedure DoOnStatusBar(StatusBar: WordBool); safecall;
    procedure DoOnFullScreen(FullScreen: WordBool); safecall;
    procedure DoOnTheaterMode(TheaterMode: WordBool); safecall;
    procedure DoNavigateError(const pDisp: IDispatch; var URL, Frame, StatusCode: OleVariant; var Cancel: WordBool); safecall;
  protected
    //SinkEventsProtected//
    FStatusTextChange : TDWebBrowserEvents2StatusTextChangeEvent;
    FProgressChange : TDWebBrowserEvents2ProgressChangeEvent;
    FCommandStateChange : TDWebBrowserEvents2CommandStateChangeEvent;
    FDownloadBegin : TDWebBrowserEvents2DownloadBeginEvent;
    FDownloadComplete : TDWebBrowserEvents2DownloadCompleteEvent;
    FTitleChange : TDWebBrowserEvents2TitleChangeEvent;
    FPropertyChange : TDWebBrowserEvents2PropertyChangeEvent;
    FBeforeNavigate2 : TDWebBrowserEvents2BeforeNavigate2Event;
    FNewWindow2 : TDWebBrowserEvents2NewWindow2Event;
    FNavigateComplete2 : TDWebBrowserEvents2NavigateComplete2Event;
    FDocumentComplete : TDWebBrowserEvents2DocumentCompleteEvent;
    FOnQuit : TDWebBrowserEvents2OnQuitEvent;
    FOnVisible : TDWebBrowserEvents2OnVisibleEvent;
    FOnToolBar : TDWebBrowserEvents2OnToolBarEvent;
    FOnMenuBar : TDWebBrowserEvents2OnMenuBarEvent;
    FOnStatusBar : TDWebBrowserEvents2OnStatusBarEvent;
    FOnFullScreen : TDWebBrowserEvents2OnFullScreenEvent;
    FOnTheaterMode : TDWebBrowserEvents2OnTheaterModeEvent;
    FNavigateError: TNavigateErrorEvent;
  published
    //SinkEventsPublished//
    property StatusTextChange : TDWebBrowserEvents2StatusTextChangeEvent read FStatusTextChange write FStatusTextChange;
    property ProgressChange : TDWebBrowserEvents2ProgressChangeEvent read FProgressChange write FProgressChange;
    property CommandStateChange : TDWebBrowserEvents2CommandStateChangeEvent read FCommandStateChange write FCommandStateChange;
    property DownloadBegin : TDWebBrowserEvents2DownloadBeginEvent read FDownloadBegin write FDownloadBegin;
    property DownloadComplete : TDWebBrowserEvents2DownloadCompleteEvent read FDownloadComplete write FDownloadComplete;
    property TitleChange : TDWebBrowserEvents2TitleChangeEvent read FTitleChange write FTitleChange;
    property PropertyChange : TDWebBrowserEvents2PropertyChangeEvent read FPropertyChange write FPropertyChange;
    property BeforeNavigate2 : TDWebBrowserEvents2BeforeNavigate2Event read FBeforeNavigate2 write FBeforeNavigate2;
    property NewWindow2 : TDWebBrowserEvents2NewWindow2Event read FNewWindow2 write FNewWindow2;
    property NavigateComplete2 : TDWebBrowserEvents2NavigateComplete2Event read FNavigateComplete2 write FNavigateComplete2;
    property DocumentComplete : TDWebBrowserEvents2DocumentCompleteEvent read FDocumentComplete write FDocumentComplete;
    property OnQuit : TDWebBrowserEvents2OnQuitEvent read FOnQuit write FOnQuit;
    property OnVisible : TDWebBrowserEvents2OnVisibleEvent read FOnVisible write FOnVisible;
    property OnToolBar : TDWebBrowserEvents2OnToolBarEvent read FOnToolBar write FOnToolBar;
    property OnMenuBar : TDWebBrowserEvents2OnMenuBarEvent read FOnMenuBar write FOnMenuBar;
    property OnStatusBar : TDWebBrowserEvents2OnStatusBarEvent read FOnStatusBar write FOnStatusBar;
    property OnFullScreen : TDWebBrowserEvents2OnFullScreenEvent read FOnFullScreen write FOnFullScreen;
    property OnTheaterMode : TDWebBrowserEvents2OnTheaterModeEvent read FOnTheaterMode write FOnTheaterMode;
    property NavigateError: TNavigateErrorEvent read FNavigateError write FNavigateError;
  end;


  //SinkEventsForwards//
  TDWebBrowserEventsBeforeNavigateEvent = procedure (Sender : TObject; const URL: WideString; Flags: Integer; const TargetFrameName: WideString; var PostData: OleVariant; const Headers: WideString; var Cancel: WordBool) of object;
  TDWebBrowserEventsNavigateCompleteEvent = procedure (Sender : TObject; const URL: WideString) of object;
  TDWebBrowserEventsStatusTextChangeEvent = procedure (Sender : TObject; const Text: WideString) of object;
  TDWebBrowserEventsProgressChangeEvent = procedure (Sender : TObject; Progress: Integer; ProgressMax: Integer) of object;
  TDWebBrowserEventsDownloadCompleteEvent = procedure (Sender : TObject) of object;
  TDWebBrowserEventsCommandStateChangeEvent = procedure (Sender : TObject; Command: Integer; Enable: WordBool) of object;
  TDWebBrowserEventsDownloadBeginEvent = procedure (Sender : TObject) of object;
  TDWebBrowserEventsNewWindowEvent = procedure (Sender : TObject; const URL: WideString; Flags: Integer; const TargetFrameName: WideString; var PostData: OleVariant; const Headers: WideString; var Processed: WordBool) of object;
  TDWebBrowserEventsTitleChangeEvent = procedure (Sender : TObject; const Text: WideString) of object;
  TDWebBrowserEventsFrameBeforeNavigateEvent = procedure (Sender : TObject; const URL: WideString; Flags: Integer; const TargetFrameName: WideString; var PostData: OleVariant; const Headers: WideString; var Cancel: WordBool) of object;
  TDWebBrowserEventsFrameNavigateCompleteEvent = procedure (Sender : TObject; const URL: WideString) of object;
  TDWebBrowserEventsFrameNewWindowEvent = procedure (Sender : TObject; const URL: WideString; Flags: Integer; const TargetFrameName: WideString; var PostData: OleVariant; const Headers: WideString; var Processed: WordBool) of object;
  TDWebBrowserEventsQuitEvent = procedure (Sender : TObject; var Cancel: WordBool) of object;
  TDWebBrowserEventsWindowMoveEvent = procedure (Sender : TObject) of object;
  TDWebBrowserEventsWindowResizeEvent = procedure (Sender : TObject) of object;
  TDWebBrowserEventsWindowActivateEvent = procedure (Sender : TObject) of object;
  TDWebBrowserEventsPropertyChangeEvent = procedure (Sender : TObject; const Property_: WideString) of object;

  //SinkComponent//
  TDWebBrowserEvents = class (TComponent, IUnknown, IDispatch
    //ISinkInterface//
  )
  protected
    { IDispatch }
    function GetIDsOfNames(const IID: TGUID; Names: Pointer;
      NameCount, LocaleID: Integer; DispIDs: Pointer): HResult; virtual; stdcall;
    function GetTypeInfo(Index, LocaleID: Integer; out TypeInfo): HResult; virtual; stdcall;
    function GetTypeInfoCount(out Count: Integer): HResult; virtual; stdcall;
    function Invoke(DispID: Integer; const IID: TGUID; LocaleID: Integer;
      Flags: Word; var Params; VarResult, ExcepInfo, ArgErr: Pointer): HResult; virtual; stdcall;

    { IUnknown }
    function QueryInterface(const IID: TGUID; out Obj): HResult; {$IFDEF VER120} override; {$ENDIF} stdcall;
    function _AddRef: Integer; stdcall;
    function _Release: Integer; stdcall;

    //ISinkInterfaceMethods//
  protected
    FCookie : integer;
    FCP : IConnectionPoint;
    FSinkIID : TGuid;
    FSource : IUnknown;
  public
    { system methods }
    constructor Create (pOwner : TComponent); override;
    destructor Destroy; override;
    procedure Connect (pSource : IUnknown);
    procedure Disconnect;
    property SinkIID : TGuid read FSinkIID;
    property Source : IUnknown read FSource;
  protected
    //SinkInterface//
    procedure DoBeforeNavigate(const URL: WideString; Flags: Integer; const TargetFrameName: WideString; var PostData: OleVariant; const Headers: WideString; var Cancel: WordBool); safecall;
    procedure DoNavigateComplete(const URL: WideString); safecall;
    procedure DoStatusTextChange(const Text: WideString); safecall;
    procedure DoProgressChange(Progress: Integer; ProgressMax: Integer); safecall;
    procedure DoDownloadComplete; safecall;
    procedure DoCommandStateChange(Command: Integer; Enable: WordBool); safecall;
    procedure DoDownloadBegin; safecall;
    procedure DoNewWindow(const URL: WideString; Flags: Integer; const TargetFrameName: WideString; var PostData: OleVariant; const Headers: WideString; var Processed: WordBool); safecall;
    procedure DoTitleChange(const Text: WideString); safecall;
    procedure DoFrameBeforeNavigate(const URL: WideString; Flags: Integer; const TargetFrameName: WideString; var PostData: OleVariant; const Headers: WideString; var Cancel: WordBool); safecall;
    procedure DoFrameNavigateComplete(const URL: WideString); safecall;
    procedure DoFrameNewWindow(const URL: WideString; Flags: Integer; const TargetFrameName: WideString; var PostData: OleVariant; const Headers: WideString; var Processed: WordBool); safecall;
    procedure DoQuit(var Cancel: WordBool); safecall;
    procedure DoWindowMove; safecall;
    procedure DoWindowResize; safecall;
    procedure DoWindowActivate; safecall;
    procedure DoPropertyChange(const Property_: WideString); safecall;

  protected
    //SinkEventsProtected//
    FBeforeNavigate : TDWebBrowserEventsBeforeNavigateEvent;
    FNavigateComplete : TDWebBrowserEventsNavigateCompleteEvent;
    FStatusTextChange : TDWebBrowserEventsStatusTextChangeEvent;
    FProgressChange : TDWebBrowserEventsProgressChangeEvent;
    FDownloadComplete : TDWebBrowserEventsDownloadCompleteEvent;
    FCommandStateChange : TDWebBrowserEventsCommandStateChangeEvent;
    FDownloadBegin : TDWebBrowserEventsDownloadBeginEvent;
    FNewWindow : TDWebBrowserEventsNewWindowEvent;
    FTitleChange : TDWebBrowserEventsTitleChangeEvent;
    FFrameBeforeNavigate : TDWebBrowserEventsFrameBeforeNavigateEvent;
    FFrameNavigateComplete : TDWebBrowserEventsFrameNavigateCompleteEvent;
    FFrameNewWindow : TDWebBrowserEventsFrameNewWindowEvent;
    FQuit : TDWebBrowserEventsQuitEvent;
    FWindowMove : TDWebBrowserEventsWindowMoveEvent;
    FWindowResize : TDWebBrowserEventsWindowResizeEvent;
    FWindowActivate : TDWebBrowserEventsWindowActivateEvent;
    FPropertyChange : TDWebBrowserEventsPropertyChangeEvent;
  published
    //SinkEventsPublished//
    property BeforeNavigate : TDWebBrowserEventsBeforeNavigateEvent read FBeforeNavigate write FBeforeNavigate;
    property NavigateComplete : TDWebBrowserEventsNavigateCompleteEvent read FNavigateComplete write FNavigateComplete;
    property StatusTextChange : TDWebBrowserEventsStatusTextChangeEvent read FStatusTextChange write FStatusTextChange;
    property ProgressChange : TDWebBrowserEventsProgressChangeEvent read FProgressChange write FProgressChange;
    property DownloadComplete : TDWebBrowserEventsDownloadCompleteEvent read FDownloadComplete write FDownloadComplete;
    property CommandStateChange : TDWebBrowserEventsCommandStateChangeEvent read FCommandStateChange write FCommandStateChange;
    property DownloadBegin : TDWebBrowserEventsDownloadBeginEvent read FDownloadBegin write FDownloadBegin;
    property NewWindow : TDWebBrowserEventsNewWindowEvent read FNewWindow write FNewWindow;
    property TitleChange : TDWebBrowserEventsTitleChangeEvent read FTitleChange write FTitleChange;
    property FrameBeforeNavigate : TDWebBrowserEventsFrameBeforeNavigateEvent read FFrameBeforeNavigate write FFrameBeforeNavigate;
    property FrameNavigateComplete : TDWebBrowserEventsFrameNavigateCompleteEvent read FFrameNavigateComplete write FFrameNavigateComplete;
    property FrameNewWindow : TDWebBrowserEventsFrameNewWindowEvent read FFrameNewWindow write FFrameNewWindow;
    property Quit : TDWebBrowserEventsQuitEvent read FQuit write FQuit;
    property WindowMove : TDWebBrowserEventsWindowMoveEvent read FWindowMove write FWindowMove;
    property WindowResize : TDWebBrowserEventsWindowResizeEvent read FWindowResize write FWindowResize;
    property WindowActivate : TDWebBrowserEventsWindowActivateEvent read FWindowActivate write FWindowActivate;
    property PropertyChange : TDWebBrowserEventsPropertyChangeEvent read FPropertyChange write FPropertyChange;

  end;
  
  
  //SinkEventsForwards//
  TDShellFolderViewEventsSelectionChangedEvent = procedure (Sender : TObject) of object;

  //SinkComponent//
  TDShellFolderViewEvents = class (TComponent, IUnknown, IDispatch
    //ISinkInterface//
  )
  protected
    { IDispatch }
    function GetIDsOfNames(const IID: TGUID; Names: Pointer;
      NameCount, LocaleID: Integer; DispIDs: Pointer): HResult; virtual; stdcall;
    function GetTypeInfo(Index, LocaleID: Integer; out TypeInfo): HResult; virtual; stdcall;
    function GetTypeInfoCount(out Count: Integer): HResult; virtual; stdcall;
    function Invoke(DispID: Integer; const IID: TGUID; LocaleID: Integer;
      Flags: Word; var Params; VarResult, ExcepInfo, ArgErr: Pointer): HResult; virtual; stdcall;

    { IUnknown }
    function QueryInterface(const IID: TGUID; out Obj): HResult; {$IFDEF VER120} override; {$ENDIF} stdcall;
    function _AddRef: Integer; stdcall;
    function _Release: Integer; stdcall;

    //ISinkInterfaceMethods//
  protected
    FCookie : integer;
    FCP : IConnectionPoint;
    FSinkIID : TGuid;
    FSource : IUnknown;
  public
    { system methods }
    constructor Create (pOwner : TComponent); override;
    destructor Destroy; override;
    procedure Connect (pSource : IUnknown);
    procedure Disconnect;
    property SinkIID : TGuid read FSinkIID;
    property Source : IUnknown read FSource;
  protected
    //SinkInterface//
    procedure DoSelectionChanged; safecall;
  protected
    //SinkEventsProtected//
    FSelectionChanged : TDShellFolderViewEventsSelectionChangedEvent;
  published
    //SinkEventsPublished//
    property SelectionChanged : TDShellFolderViewEventsSelectionChangedEvent read FSelectionChanged write FSelectionChanged;
  end;
  
  
  //SinkEventsForwards//
  TDShellWindowsEventsWindowRegisteredEvent = procedure (Sender : TObject; lCookie: Integer) of object;
  TDShellWindowsEventsWindowRevokedEvent = procedure (Sender : TObject; lCookie: Integer) of object;

  //SinkComponent//
  TDShellWindowsEvents = class (TComponent, IUnknown, IDispatch
    //ISinkInterface//
  )
  protected
    { IDispatch }
    function GetIDsOfNames(const IID: TGUID; Names: Pointer;
      NameCount, LocaleID: Integer; DispIDs: Pointer): HResult; virtual; stdcall;
    function GetTypeInfo(Index, LocaleID: Integer; out TypeInfo): HResult; virtual; stdcall;
    function GetTypeInfoCount(out Count: Integer): HResult; virtual; stdcall;
    function Invoke(DispID: Integer; const IID: TGUID; LocaleID: Integer;
      Flags: Word; var Params; VarResult, ExcepInfo, ArgErr: Pointer): HResult; virtual; stdcall;

    { IUnknown }
    function QueryInterface(const IID: TGUID; out Obj): HResult; {$IFDEF VER120} override; {$ENDIF} stdcall;
    function _AddRef: Integer; stdcall;
    function _Release: Integer; stdcall;

    //ISinkInterfaceMethods//
  protected
    FCookie : integer;
    FCP : IConnectionPoint;
    FSinkIID : TGuid;
    FSource : IUnknown;
  public
    { system methods }
    constructor Create (pOwner : TComponent); override;
    destructor Destroy; override;
    procedure Connect (pSource : IUnknown);
    procedure Disconnect;
    property SinkIID : TGuid read FSinkIID;
    property Source : IUnknown read FSource;
  protected
    //SinkInterface//
    procedure DoWindowRegistered(lCookie: Integer); safecall;
    procedure DoWindowRevoked(lCookie: Integer); safecall;
  protected
    //SinkEventsProtected//
    FWindowRegistered : TDShellWindowsEventsWindowRegisteredEvent;
    FWindowRevoked : TDShellWindowsEventsWindowRevokedEvent;
  published
    //SinkEventsPublished//
    property WindowRegistered : TDShellWindowsEventsWindowRegisteredEvent read FWindowRegistered write FWindowRegistered;
    property WindowRevoked : TDShellWindowsEventsWindowRevokedEvent read FWindowRevoked write FWindowRevoked;
  end;
  
  //SinkIntfEnd//

procedure Register;

implementation

uses
  SysUtils
  ;

{ globals }

procedure BuildPositionalDispIds (pDispIds : PDispIdList; const dps : TDispParams);
var
  i : integer;
begin
  Assert (pDispIds <> NIL);
  
  { by default, directly arrange in reverse order }
  for i := 0 to dps.cArgs - 1 do
    pDispIds^ [i] := dps.cArgs - 1 - i;

  { check for named args }
  if (dps.cNamedArgs <= 0) then Exit;

  { parse named args }
  for i := 0 to dps.cNamedArgs - 1 do
    pDispIds^ [dps.rgdispidNamedArgs^ [i]] := i;
end;


//SinkImplStart//

function TDWebBrowserEvents2.GetIDsOfNames(const IID: TGUID; Names: Pointer;
  NameCount, LocaleID: Integer; DispIDs: Pointer): HResult;
begin
  Result := E_NOTIMPL;
end;

function TDWebBrowserEvents2.GetTypeInfo(Index, LocaleID: Integer; out TypeInfo): HResult;
begin
  Result := E_NOTIMPL;
  pointer (TypeInfo) := NIL;
end;

function TDWebBrowserEvents2.GetTypeInfoCount(out Count: Integer): HResult;
begin
  Result := E_NOTIMPL;
  Count := 0;
end;

function TDWebBrowserEvents2.Invoke(DispID: Integer; const IID: TGUID; LocaleID: Integer;
  Flags: Word; var Params; VarResult, ExcepInfo, ArgErr: Pointer): HResult;
type
  POleVariant = ^OleVariant;
var
  dps : TDispParams absolute Params;
  bHasParams : boolean;
  pDispIds : PDispIdList;
  iDispIdsSize : integer;
begin
  Result := DISP_E_MEMBERNOTFOUND;

  { validity checks }
  if (Flags AND DISPATCH_METHOD = 0) then
    raise Exception.Create (
      Format ('%s only supports sinking of method calls!', [ClassName]
    ));

  { build pDispIds array. this maybe a bit of overhead but it allows us to
    sink named-argument calls such as Excel's AppEvents, etc!
  }
  pDispIds := NIL;
  iDispIdsSize := 0;
  bHasParams := (dps.cArgs > 0);
  if (bHasParams) then
  begin
    iDispIdsSize := dps.cArgs * SizeOf (TDispId);
    GetMem (pDispIds, iDispIdsSize);
  end;  { if }
  
  try
    { rearrange dispids properly }
    if (bHasParams) then BuildPositionalDispIds (pDispIds, dps);

    //SinkInvoke//
    case DispId of
      102 :
      begin
        DoStatusTextChange (dps.rgvarg^ [pDispIds^ [0]].bstrval);
        Result := S_OK;
      end;
      108 :
      begin
        DoProgressChange (dps.rgvarg^ [pDispIds^ [0]].lval, dps.rgvarg^ [pDispIds^ [1]].lval);
        Result := S_OK;
      end;
      105 :
      begin
        DoCommandStateChange (dps.rgvarg^ [pDispIds^ [0]].lval, dps.rgvarg^ [pDispIds^ [1]].vbool);
        Result := S_OK;
      end;
      106 :
      begin
        DoDownloadBegin ();
        Result := S_OK;
      end;
      104 :
      begin
        DoDownloadComplete ();
        Result := S_OK;
      end;
      113 :
      begin
        DoTitleChange (dps.rgvarg^ [pDispIds^ [0]].bstrval);
        Result := S_OK;
      end;
      112 :
      begin
        DoPropertyChange (dps.rgvarg^ [pDispIds^ [0]].bstrval);
        Result := S_OK;
      end;
      250 :
      begin
        DoBeforeNavigate2 (IDispatch (dps.rgvarg^ [pDispIds^ [0]].dispval), POleVariant (dps.rgvarg^ [pDispIds^ [1]].pvarval)^, POleVariant (dps.rgvarg^ [pDispIds^ [2]].pvarval)^, POleVariant (dps.rgvarg^ [pDispIds^ [3]].pvarval)^, POleVariant (dps.rgvarg^ [pDispIds^ [4]].pvarval)^, POleVariant (dps.rgvarg^ [pDispIds^ [5]].pvarval)^, dps.rgvarg^ [pDispIds^ [6]].pbool^);
        Result := S_OK;
      end;
      251 :
      begin
        DoNewWindow2 (IDispatch (dps.rgvarg^ [pDispIds^ [0]].pdispval^), dps.rgvarg^ [pDispIds^ [1]].pbool^);
        Result := S_OK;
      end;
      252 :
      begin
        DoNavigateComplete2 (IDispatch (dps.rgvarg^ [pDispIds^ [0]].dispval), POleVariant (dps.rgvarg^ [pDispIds^ [1]].pvarval)^);
        Result := S_OK;
      end;
      259 :
      begin
        DoDocumentComplete (IDispatch (dps.rgvarg^ [pDispIds^ [0]].dispval), POleVariant (dps.rgvarg^ [pDispIds^ [1]].pvarval)^);
        Result := S_OK;
      end;
      253 :
      begin
        DoOnQuit ();
        Result := S_OK;
      end;
      254 :
      begin
        DoOnVisible (dps.rgvarg^ [pDispIds^ [0]].vbool);
        Result := S_OK;
      end;
      255 :
      begin
        DoOnToolBar (dps.rgvarg^ [pDispIds^ [0]].vbool);
        Result := S_OK;
      end;
      256 :
      begin
        DoOnMenuBar (dps.rgvarg^ [pDispIds^ [0]].vbool);
        Result := S_OK;
      end;
      257 :
      begin
        DoOnStatusBar (dps.rgvarg^ [pDispIds^ [0]].vbool);
        Result := S_OK;
      end;
      258 :
      begin
        DoOnFullScreen (dps.rgvarg^ [pDispIds^ [0]].vbool);
        Result := S_OK;
      end;
      260 :
      begin
        DoOnTheaterMode (dps.rgvarg^ [pDispIds^ [0]].vbool);
        Result := S_OK;
      end;
      271: begin
        DoNavigateError (IDispatch (dps.rgvarg^ [pDispIds^ [0]].dispval), POleVariant (dps.rgvarg^ [pDispIds^ [1]].pvarval)^, POleVariant (dps.rgvarg^ [pDispIds^ [2]].pvarval)^, POleVariant (dps.rgvarg^ [pDispIds^ [3]].pvarval)^, dps.rgvarg^ [pDispIds^ [4]].pbool^);
        Result := S_OK;
      end;

    end;  { case }
    //SinkInvokeEnd//
  finally
    { free pDispIds array }
    if (bHasParams) then FreeMem (pDispIds, iDispIdsSize);
  end;  { finally }
end;

function TDWebBrowserEvents2.QueryInterface(const IID: TGUID; out Obj): HResult;
begin
  Result := E_NOINTERFACE;
  pointer (Obj) := NIL;
  if (GetInterface (IID, Obj)) then Result := S_OK;
  if not Succeeded (Result) then
    if (IsEqualIID (IID, FSinkIID)) then
      if (GetInterface (IDispatch, Obj)) then
        Result := S_OK;
end;

function TDWebBrowserEvents2._AddRef: Integer;
begin
  Result := 2;
end;

function TDWebBrowserEvents2._Release: Integer;
begin
  Result := 1;
end;

constructor TDWebBrowserEvents2.Create (pOwner : TComponent);
begin
  inherited Create (pOwner);

  //SinkInit//
  FSinkIID := DWebBrowserEvents2;
end;

destructor TDWebBrowserEvents2.Destroy;
begin
  Disconnect;
  inherited;
end;

procedure TDWebBrowserEvents2.Connect (pSource : IUnknown);
var
  pcpc : IConnectionPointContainer;
begin
  Assert (pSource <> NIL);
  Disconnect;
  try
    OleCheck (pSource.QueryInterface (IConnectionPointContainer, pcpc));
    OleCheck (pcpc.FindConnectionPoint (FSinkIID, FCP));
    OleCheck (FCP.Advise (Self, FCookie));
    FSource := pSource;
  except
    raise Exception.Create (Format ('Unable to connect %s.'#13'%s',
      [Name, Exception (ExceptObject).Message]
    ));
  end;  { finally }
end;

procedure TDWebBrowserEvents2.Disconnect;
begin
  if (FSource = NIL) then Exit;
  try
    OleCheck (FCP.Unadvise (FCookie));
    FCP := NIL;
    FSource := NIL;
  except
    pointer (FCP) := NIL;
    pointer (FSource) := NIL;
  end;  { except }
end;

//SinkImplementation//
procedure TDWebBrowserEvents2.DoStatusTextChange(const Text: WideString);
begin
  if not Assigned (StatusTextChange) then Exit;
  StatusTextChange (Self, Text);
end;

procedure TDWebBrowserEvents2.DoProgressChange(Progress: Integer; ProgressMax: Integer);
begin
  if not Assigned (ProgressChange) then Exit;
  ProgressChange (Self, Progress, ProgressMax);
end;

procedure TDWebBrowserEvents2.DoCommandStateChange(Command: Integer; Enable: WordBool);
begin
  if not Assigned (CommandStateChange) then Exit;
  CommandStateChange (Self, Command, Enable);
end;

procedure TDWebBrowserEvents2.DoDownloadBegin;
begin
  if not Assigned (DownloadBegin) then Exit;
  DownloadBegin (Self);
end;

procedure TDWebBrowserEvents2.DoDownloadComplete;
begin
  if not Assigned (DownloadComplete) then Exit;
  DownloadComplete (Self);
end;

procedure TDWebBrowserEvents2.DoTitleChange(const Text: WideString);
begin
  if not Assigned (TitleChange) then Exit;
  TitleChange (Self, Text);
end;

procedure TDWebBrowserEvents2.DoPropertyChange(const szProperty: WideString);
begin
  if not Assigned (PropertyChange) then Exit;
  PropertyChange (Self, szProperty);
end;

procedure TDWebBrowserEvents2.DoBeforeNavigate2(const pDisp: IDispatch; var URL: OleVariant; var Flags: OleVariant; var TargetFrameName: OleVariant; var PostData: OleVariant; var Headers: OleVariant; var Cancel: WordBool);
begin
  if not Assigned (BeforeNavigate2) then Exit;
  BeforeNavigate2 (Self, pDisp, URL, Flags, TargetFrameName, PostData, Headers, Cancel);
end;

procedure TDWebBrowserEvents2.DoNewWindow2(var ppDisp: IDispatch; var Cancel: WordBool);
var
  pppDisp : IDispatch;
begin
  if not Assigned (NewWindow2) then Exit;
  if (ppDisp <> NIL) then pppDisp := ppDisp as IDispatch else pppDisp := NIL;
  NewWindow2 (Self, pppDisp, Cancel);
  ppDisp := pppDisp;
end;

procedure TDWebBrowserEvents2.DoNavigateComplete2(const pDisp: IDispatch; var URL: OleVariant);
begin
  if not Assigned (NavigateComplete2) then Exit;
  NavigateComplete2 (Self, pDisp, URL);
end;

procedure TDWebBrowserEvents2.DoDocumentComplete(const pDisp: IDispatch; var URL: OleVariant);
begin
  if not Assigned (DocumentComplete) then Exit;
  DocumentComplete (Self, pDisp, URL);
end;

procedure TDWebBrowserEvents2.DoOnQuit;
begin
  if not Assigned (OnQuit) then Exit;
  OnQuit (Self);
end;

procedure TDWebBrowserEvents2.DoOnVisible(Visible: WordBool);
begin
  if not Assigned (OnVisible) then Exit;
  OnVisible (Self, Visible);
end;

procedure TDWebBrowserEvents2.DoOnToolBar(ToolBar: WordBool);
begin
  if not Assigned (OnToolBar) then Exit;
  OnToolBar (Self, ToolBar);
end;

procedure TDWebBrowserEvents2.DoOnMenuBar(MenuBar: WordBool);
begin
  if not Assigned (OnMenuBar) then Exit;
  OnMenuBar (Self, MenuBar);
end;

procedure TDWebBrowserEvents2.DoOnStatusBar(StatusBar: WordBool);
begin
  if not Assigned (OnStatusBar) then Exit;
  OnStatusBar (Self, StatusBar);
end;

procedure TDWebBrowserEvents2.DoOnFullScreen(FullScreen: WordBool);
begin
  if not Assigned (OnFullScreen) then Exit;
  OnFullScreen (Self, FullScreen);
end;

procedure TDWebBrowserEvents2.DoOnTheaterMode(TheaterMode: WordBool);
begin
  if not Assigned (OnTheaterMode) then Exit;
  OnTheaterMode (Self, TheaterMode);
end;



function TDWebBrowserEvents.GetIDsOfNames(const IID: TGUID; Names: Pointer;
  NameCount, LocaleID: Integer; DispIDs: Pointer): HResult;
begin
  Result := E_NOTIMPL;
end;

function TDWebBrowserEvents.GetTypeInfo(Index, LocaleID: Integer; out TypeInfo): HResult;
begin
  Result := E_NOTIMPL;
  pointer (TypeInfo) := NIL;
end;

function TDWebBrowserEvents.GetTypeInfoCount(out Count: Integer): HResult;
begin
  Result := E_NOTIMPL;
  Count := 0;
end;

function TDWebBrowserEvents.Invoke(DispID: Integer; const IID: TGUID; LocaleID: Integer;
  Flags: Word; var Params; VarResult, ExcepInfo, ArgErr: Pointer): HResult;
type
  POleVariant = ^OleVariant;
var
  dps : TDispParams absolute Params;
  bHasParams : boolean;
  pDispIds : PDispIdList;
  iDispIdsSize : integer;
begin
  Result := DISP_E_MEMBERNOTFOUND;

  { validity checks }
  if (Flags AND DISPATCH_METHOD = 0) then
    raise Exception.Create (
      Format ('%s only supports sinking of method calls!', [ClassName]
    ));

  { build pDispIds array. this maybe a bit of overhead but it allows us to
    sink named-argument calls such as Excel's AppEvents, etc!
  }
  pDispIds := NIL;
  iDispIdsSize := 0;
  bHasParams := (dps.cArgs > 0);
  if (bHasParams) then
  begin
    iDispIdsSize := dps.cArgs * SizeOf (TDispId);
    GetMem (pDispIds, iDispIdsSize);
  end;  { if }

  try
    { rearrange dispids properly }
    if (bHasParams) then BuildPositionalDispIds (pDispIds, dps);

    //SinkInvoke//
    case DispId of
      100 :
      begin
        DoBeforeNavigate (dps.rgvarg^ [pDispIds^ [0]].bstrval, dps.rgvarg^ [pDispIds^ [1]].lval, dps.rgvarg^ [pDispIds^ [2]].bstrval, POleVariant (dps.rgvarg^ [pDispIds^ [3]].pvarval)^, dps.rgvarg^ [pDispIds^ [4]].bstrval, dps.rgvarg^ [pDispIds^ [5]].pbool^);
        Result := S_OK;
      end;
      101 :
      begin
        DoNavigateComplete (dps.rgvarg^ [pDispIds^ [0]].bstrval);
        Result := S_OK;
      end;
      102 :
      begin
        DoStatusTextChange (dps.rgvarg^ [pDispIds^ [0]].bstrval);
        Result := S_OK;
      end;
      108 :
      begin
        DoProgressChange (dps.rgvarg^ [pDispIds^ [0]].lval, dps.rgvarg^ [pDispIds^ [1]].lval);
        Result := S_OK;
      end;
      104 :
      begin
        DoDownloadComplete ();
        Result := S_OK;
      end;
      105 :
      begin
        DoCommandStateChange (dps.rgvarg^ [pDispIds^ [0]].lval, dps.rgvarg^ [pDispIds^ [1]].vbool);
        Result := S_OK;
      end;
      106 :
      begin
        DoDownloadBegin ();
        Result := S_OK;
      end;
      107 :
      begin
        DoNewWindow (dps.rgvarg^ [pDispIds^ [0]].bstrval, dps.rgvarg^ [pDispIds^ [1]].lval, dps.rgvarg^ [pDispIds^ [2]].bstrval, POleVariant (dps.rgvarg^ [pDispIds^ [3]].pvarval)^, dps.rgvarg^ [pDispIds^ [4]].bstrval, dps.rgvarg^ [pDispIds^ [5]].pbool^);
        Result := S_OK;
      end;
      113 :
      begin
        DoTitleChange (dps.rgvarg^ [pDispIds^ [0]].bstrval);
        Result := S_OK;
      end;
      200 :
      begin
        DoFrameBeforeNavigate (dps.rgvarg^ [pDispIds^ [0]].bstrval, dps.rgvarg^ [pDispIds^ [1]].lval, dps.rgvarg^ [pDispIds^ [2]].bstrval, POleVariant (dps.rgvarg^ [pDispIds^ [3]].pvarval)^, dps.rgvarg^ [pDispIds^ [4]].bstrval, dps.rgvarg^ [pDispIds^ [5]].pbool^);
        Result := S_OK;
      end;
      201 :
      begin
        DoFrameNavigateComplete (dps.rgvarg^ [pDispIds^ [0]].bstrval);
        Result := S_OK;
      end;
      204 :
      begin
        DoFrameNewWindow (dps.rgvarg^ [pDispIds^ [0]].bstrval, dps.rgvarg^ [pDispIds^ [1]].lval, dps.rgvarg^ [pDispIds^ [2]].bstrval, POleVariant (dps.rgvarg^ [pDispIds^ [3]].pvarval)^, dps.rgvarg^ [pDispIds^ [4]].bstrval, dps.rgvarg^ [pDispIds^ [5]].pbool^);
        Result := S_OK;
      end;
      103 :
      begin
        DoQuit (dps.rgvarg^ [pDispIds^ [0]].pbool^);
        Result := S_OK;
      end;
      109 :
      begin
        DoWindowMove ();
        Result := S_OK;
      end;
      110 :
      begin
        DoWindowResize ();
        Result := S_OK;
      end;
      111 :
      begin
        DoWindowActivate ();
        Result := S_OK;
      end;
      112 :
      begin
        DoPropertyChange (dps.rgvarg^ [pDispIds^ [0]].bstrval);
        Result := S_OK;
      end;
    end;  { case }
    //SinkInvokeEnd//
  finally
    { free pDispIds array }
    if (bHasParams) then FreeMem (pDispIds, iDispIdsSize);
  end;  { finally }
end;

function TDWebBrowserEvents.QueryInterface(const IID: TGUID; out Obj): HResult;
begin
  Result := E_NOINTERFACE;
  pointer (Obj) := NIL;
  if (GetInterface (IID, Obj)) then Result := S_OK;
  if not Succeeded (Result) then
    if (IsEqualIID (IID, FSinkIID)) then
      if (GetInterface (IDispatch, Obj)) then
        Result := S_OK;
end;

function TDWebBrowserEvents._AddRef: Integer;
begin
  Result := 2;
end;

function TDWebBrowserEvents._Release: Integer;
begin
  Result := 1;
end;

constructor TDWebBrowserEvents.Create (pOwner : TComponent);
begin
  inherited Create (pOwner);

  //SinkInit//
  FSinkIID := DWebBrowserEvents;
end;

destructor TDWebBrowserEvents.Destroy;
begin
  Disconnect;
  inherited;
end;

procedure TDWebBrowserEvents.Connect (pSource : IUnknown);
var
  pcpc : IConnectionPointContainer;
begin
  Assert (pSource <> NIL);
  Disconnect;
  try
    OleCheck (pSource.QueryInterface (IConnectionPointContainer, pcpc));
    OleCheck (pcpc.FindConnectionPoint (FSinkIID, FCP));
    OleCheck (FCP.Advise (Self, FCookie));
    FSource := pSource;
  except
    raise Exception.Create (Format ('Unable to connect %s.'#13'%s',
      [Name, Exception (ExceptObject).Message]
    ));
  end;  { finally }
end;

procedure TDWebBrowserEvents.Disconnect;
begin
  if (FSource = NIL) then Exit;
  try
    OleCheck (FCP.Unadvise (FCookie));
    FCP := NIL;
    FSource := NIL;
  except
    pointer (FCP) := NIL;
    pointer (FSource) := NIL;
  end;  { except }
end;

//SinkImplementation//
procedure TDWebBrowserEvents.DoBeforeNavigate(const URL: WideString; Flags: Integer; const TargetFrameName: WideString; var PostData: OleVariant; const Headers: WideString; var Cancel: WordBool);
begin
  if not Assigned (BeforeNavigate) then Exit;
  BeforeNavigate (Self, URL, Flags, TargetFrameName, PostData, Headers, Cancel);
end;

procedure TDWebBrowserEvents.DoNavigateComplete(const URL: WideString);
begin
  if not Assigned (NavigateComplete) then Exit;
  NavigateComplete (Self, URL);
end;

procedure TDWebBrowserEvents.DoStatusTextChange(const Text: WideString);
begin
  if not Assigned (StatusTextChange) then Exit;
  StatusTextChange (Self, Text);
end;

procedure TDWebBrowserEvents.DoProgressChange(Progress: Integer; ProgressMax: Integer);
begin
  if not Assigned (ProgressChange) then Exit;
  ProgressChange (Self, Progress, ProgressMax);
end;

procedure TDWebBrowserEvents.DoDownloadComplete;
begin
  if not Assigned (DownloadComplete) then Exit;
  DownloadComplete (Self);
end;

procedure TDWebBrowserEvents.DoCommandStateChange(Command: Integer; Enable: WordBool);
begin
  if not Assigned (CommandStateChange) then Exit;
  CommandStateChange (Self, Command, Enable);
end;

procedure TDWebBrowserEvents.DoDownloadBegin;
begin
  if not Assigned (DownloadBegin) then Exit;
  DownloadBegin (Self);
end;

procedure TDWebBrowserEvents.DoNewWindow(const URL: WideString; Flags: Integer; const TargetFrameName: WideString; var PostData: OleVariant; const Headers: WideString; var Processed: WordBool);
begin
  if not Assigned (NewWindow) then Exit;
  NewWindow (Self, URL, Flags, TargetFrameName, PostData, Headers, Processed);
end;

procedure TDWebBrowserEvents.DoTitleChange(const Text: WideString);
begin
  if not Assigned (TitleChange) then Exit;
  TitleChange (Self, Text);
end;

procedure TDWebBrowserEvents.DoFrameBeforeNavigate(const URL: WideString; Flags: Integer; const TargetFrameName: WideString; var PostData: OleVariant; const Headers: WideString; var Cancel: WordBool);
begin
  if not Assigned (FrameBeforeNavigate) then Exit;
  FrameBeforeNavigate (Self, URL, Flags, TargetFrameName, PostData, Headers, Cancel);
end;

procedure TDWebBrowserEvents.DoFrameNavigateComplete(const URL: WideString);
begin
  if not Assigned (FrameNavigateComplete) then Exit;
  FrameNavigateComplete (Self, URL);
end;

procedure TDWebBrowserEvents.DoFrameNewWindow(const URL: WideString; Flags: Integer; const TargetFrameName: WideString; var PostData: OleVariant; const Headers: WideString; var Processed: WordBool);
begin
  if not Assigned (FrameNewWindow) then Exit;
  FrameNewWindow (Self, URL, Flags, TargetFrameName, PostData, Headers, Processed);
end;

procedure TDWebBrowserEvents.DoQuit(var Cancel: WordBool);
begin
  if not Assigned (Quit) then Exit;
  Quit (Self, Cancel);
end;

procedure TDWebBrowserEvents.DoWindowMove;
begin
  if not Assigned (WindowMove) then Exit;
  WindowMove (Self);
end;

procedure TDWebBrowserEvents.DoWindowResize;
begin
  if not Assigned (WindowResize) then Exit;
  WindowResize (Self);
end;

procedure TDWebBrowserEvents.DoWindowActivate;
begin
  if not Assigned (WindowActivate) then Exit;
  WindowActivate (Self);
end;

procedure TDWebBrowserEvents.DoPropertyChange(const Property_: WideString);
begin
  if not Assigned (PropertyChange) then Exit;
  PropertyChange (Self, Property_);
end;

procedure TDWebBrowserEvents2.DoNavigateError(const pDisp: IDispatch; var URL: OleVariant; var Frame: OleVariant; var StatusCode: OleVariant; var Cancel: WordBool);
begin
  if not Assigned (NavigateError) then System.Exit;
  NavigateError (Self, pDisp, URL, Frame, StatusCode, Cancel);
end;



function TDShellFolderViewEvents.GetIDsOfNames(const IID: TGUID; Names: Pointer;
  NameCount, LocaleID: Integer; DispIDs: Pointer): HResult;
begin
  Result := E_NOTIMPL;
end;

function TDShellFolderViewEvents.GetTypeInfo(Index, LocaleID: Integer; out TypeInfo): HResult;
begin
  Result := E_NOTIMPL;
  pointer (TypeInfo) := NIL;
end;

function TDShellFolderViewEvents.GetTypeInfoCount(out Count: Integer): HResult;
begin
  Result := E_NOTIMPL;
  Count := 0;
end;

function TDShellFolderViewEvents.Invoke(DispID: Integer; const IID: TGUID; LocaleID: Integer;
  Flags: Word; var Params; VarResult, ExcepInfo, ArgErr: Pointer): HResult;
type
  POleVariant = ^OleVariant;
var
  dps : TDispParams absolute Params;
  bHasParams : boolean;
  pDispIds : PDispIdList;
  iDispIdsSize : integer;
begin
  Result := DISP_E_MEMBERNOTFOUND;

  { validity checks }
  if (Flags AND DISPATCH_METHOD = 0) then
    raise Exception.Create (
      Format ('%s only supports sinking of method calls!', [ClassName]
    ));

  { build pDispIds array. this maybe a bit of overhead but it allows us to
    sink named-argument calls such as Excel's AppEvents, etc!
  }
  pDispIds := NIL;
  iDispIdsSize := 0;
  bHasParams := (dps.cArgs > 0);
  if (bHasParams) then
  begin
    iDispIdsSize := dps.cArgs * SizeOf (TDispId);
    GetMem (pDispIds, iDispIdsSize);
  end;  { if }

  try
    { rearrange dispids properly }
    if (bHasParams) then BuildPositionalDispIds (pDispIds, dps);

    //SinkInvoke//
    case DispId of
      200 :
      begin
        DoSelectionChanged ();
        Result := S_OK;
      end;
    end;  { case }
    //SinkInvokeEnd//
  finally
    { free pDispIds array }
    if (bHasParams) then FreeMem (pDispIds, iDispIdsSize);
  end;  { finally }
end;

function TDShellFolderViewEvents.QueryInterface(const IID: TGUID; out Obj): HResult;
begin
  Result := E_NOINTERFACE;
  pointer (Obj) := NIL;
  if (GetInterface (IID, Obj)) then Result := S_OK;
  if not Succeeded (Result) then
    if (IsEqualIID (IID, FSinkIID)) then
      if (GetInterface (IDispatch, Obj)) then
        Result := S_OK;
end;

function TDShellFolderViewEvents._AddRef: Integer;
begin
  Result := 2;
end;

function TDShellFolderViewEvents._Release: Integer;
begin
  Result := 1;
end;

constructor TDShellFolderViewEvents.Create (pOwner : TComponent);
begin
  inherited Create (pOwner);

  //SinkInit//
  //FSinkIID := DShellFolderViewEvents;
end;

destructor TDShellFolderViewEvents.Destroy;
begin
  Disconnect;
  inherited;
end;

procedure TDShellFolderViewEvents.Connect (pSource : IUnknown);
var
  pcpc : IConnectionPointContainer;
begin
  Assert (pSource <> NIL);
  Disconnect;
  try
    OleCheck (pSource.QueryInterface (IConnectionPointContainer, pcpc));
    OleCheck (pcpc.FindConnectionPoint (FSinkIID, FCP));
    OleCheck (FCP.Advise (Self, FCookie));
    FSource := pSource;
  except
    raise Exception.Create (Format ('Unable to connect %s.'#13'%s',
      [Name, Exception (ExceptObject).Message]
    ));
  end;  { finally }
end;

procedure TDShellFolderViewEvents.Disconnect;
begin
  if (FSource = NIL) then Exit;
  try
    OleCheck (FCP.Unadvise (FCookie));
    FCP := NIL;
    FSource := NIL;
  except
    pointer (FCP) := NIL;
    pointer (FSource) := NIL;
  end;  { except }
end;

//SinkImplementation//
procedure TDShellFolderViewEvents.DoSelectionChanged;
begin
  if not Assigned (SelectionChanged) then Exit;
  SelectionChanged (Self);
end;



function TDShellWindowsEvents.GetIDsOfNames(const IID: TGUID; Names: Pointer;
  NameCount, LocaleID: Integer; DispIDs: Pointer): HResult;
begin
  Result := E_NOTIMPL;
end;

function TDShellWindowsEvents.GetTypeInfo(Index, LocaleID: Integer; out TypeInfo): HResult;
begin
  Result := E_NOTIMPL;
  pointer (TypeInfo) := NIL;
end;

function TDShellWindowsEvents.GetTypeInfoCount(out Count: Integer): HResult;
begin
  Result := E_NOTIMPL;
  Count := 0;
end;

function TDShellWindowsEvents.Invoke(DispID: Integer; const IID: TGUID; LocaleID: Integer;
  Flags: Word; var Params; VarResult, ExcepInfo, ArgErr: Pointer): HResult;
type
  POleVariant = ^OleVariant;
var
  dps : TDispParams absolute Params;
  bHasParams : boolean;
  pDispIds : PDispIdList;
  iDispIdsSize : integer;
begin
  Result := DISP_E_MEMBERNOTFOUND;

  { validity checks }
  if (Flags AND DISPATCH_METHOD = 0) then
    raise Exception.Create (
      Format ('%s only supports sinking of method calls!', [ClassName]
    ));

  { build pDispIds array. this maybe a bit of overhead but it allows us to
    sink named-argument calls such as Excel's AppEvents, etc!
  }
  pDispIds := NIL;
  iDispIdsSize := 0;
  bHasParams := (dps.cArgs > 0);
  if (bHasParams) then
  begin
    iDispIdsSize := dps.cArgs * SizeOf (TDispId);
    GetMem (pDispIds, iDispIdsSize);
  end;  { if }
  
  try
    { rearrange dispids properly }
    if (bHasParams) then BuildPositionalDispIds (pDispIds, dps);

    //SinkInvoke//
    case DispId of
      200 :
      begin
        DoWindowRegistered (dps.rgvarg^ [pDispIds^ [0]].lval);
        Result := S_OK;
      end;
      201 :
      begin
        DoWindowRevoked (dps.rgvarg^ [pDispIds^ [0]].lval);
        Result := S_OK;
      end;
    end;  { case }
    //SinkInvokeEnd//
  finally
    { free pDispIds array }
    if (bHasParams) then FreeMem (pDispIds, iDispIdsSize);
  end;  { finally }
end;

function TDShellWindowsEvents.QueryInterface(const IID: TGUID; out Obj): HResult;
begin
  Result := E_NOINTERFACE;
  pointer (Obj) := NIL;
  if (GetInterface (IID, Obj)) then Result := S_OK;
  if not Succeeded (Result) then
    if (IsEqualIID (IID, FSinkIID)) then
      if (GetInterface (IDispatch, Obj)) then
        Result := S_OK;
end;

function TDShellWindowsEvents._AddRef: Integer;
begin
  Result := 2;
end;

function TDShellWindowsEvents._Release: Integer;
begin
  Result := 1;
end;

constructor TDShellWindowsEvents.Create (pOwner : TComponent);
begin
  inherited Create (pOwner);

  //SinkInit//
  //FSinkIID := DShellWindowsEvents;
end;

destructor TDShellWindowsEvents.Destroy;
begin
  Disconnect;
  inherited;
end;

procedure TDShellWindowsEvents.Connect (pSource : IUnknown);
var
  pcpc : IConnectionPointContainer;
begin
  Assert (pSource <> NIL);
  Disconnect;
  try
    OleCheck (pSource.QueryInterface (IConnectionPointContainer, pcpc));
    OleCheck (pcpc.FindConnectionPoint (FSinkIID, FCP));
    OleCheck (FCP.Advise (Self, FCookie));
    FSource := pSource;
  except
    raise Exception.Create (Format ('Unable to connect %s.'#13'%s',
      [Name, Exception (ExceptObject).Message]
    ));
  end;  { finally }
end;

procedure TDShellWindowsEvents.Disconnect;
begin
  if (FSource = NIL) then Exit;
  try
    OleCheck (FCP.Unadvise (FCookie));
    FCP := NIL;
    FSource := NIL;
  except
    pointer (FCP) := NIL;
    pointer (FSource) := NIL;
  end;  { except }
end;

//SinkImplementation//
procedure TDShellWindowsEvents.DoWindowRegistered(lCookie: Integer);
begin
  if not Assigned (WindowRegistered) then Exit;
  WindowRegistered (Self, lCookie);
end;

procedure TDShellWindowsEvents.DoWindowRevoked(lCookie: Integer);
begin
  if not Assigned (WindowRevoked) then Exit;
  WindowRevoked (Self, lCookie);
end;


//SinkImplEnd//

procedure Register;
begin
  //SinkRegisterStart//
  RegisterComponents ('ActiveX', [TDWebBrowserEvents2]);
  RegisterComponents ('ActiveX', [TDWebBrowserEvents]);
  RegisterComponents ('ActiveX', [TDShellFolderViewEvents]);
  RegisterComponents ('ActiveX', [TDShellWindowsEvents]);
  //SinkRegisterEnd//
end;

end.
